module multiplication_mod_15(inp1, inp2, out);
	input [3:0] inp1;
	input [3:0] inp2;
	output [3:0] out;
	wire [4:0] plus;
	wire [4:0] minus;
	wire [3:0] plout;
	wire [3:0] miout;
	assign plus = inp1 + inp2; // [0; 28]
	assign minus = 14 + inp1 - inp2; // [0; 28]
	lut_sqr_sum ls1(plus, plout);
	lut_sqr_sub ls2(minus, miout);
	sub_mod_15 sub1(plout, miout, out);
endmodule

module lut_sqr_sum (in, out);
	input [4:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
	case (in)
	0: out = 0;
	1: out = 4;
	2: out = 1;
	3: out = 6;
	4: out = 4;
	5: out = 10;
	6: out = 9;
	7: out = 1;
	8: out = 1;
	9: out = 9;
	10: out = 10;
	11: out = 4;
	12: out = 6;
	13: out = 1;
	14: out = 4;
	15: out = 0;
	16: out = 4;
	17: out = 1;
	18: out = 6;
	19: out = 4;
	20: out = 10;
	21: out = 9;
	22: out = 1;
	23: out = 1;
	24: out = 9;
	25: out = 10;
	26: out = 4;
	27: out = 6;
	28: out = 1;
	default: out = 0;
	endcase
	end
endmodule

module lut_sqr_sub (in, out);
	input [4:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
	case (in)
	0: out = 4;
	1: out = 1;
	2: out = 6;
	3: out = 4;
	4: out = 10;
	5: out = 9;
	6: out = 1;
	7: out = 1;
	8: out = 9;
	9: out = 10;
	10: out = 4;
	11: out = 6;
	12: out = 1;
	13: out = 4;
	14: out = 0;
	15: out = 4;
	16: out = 1;
	17: out = 6;
	18: out = 4;
	19: out = 10;
	20: out = 9;
	21: out = 1;
	22: out = 1;
	23: out = 9;
	24: out = 10;
	25: out = 4;
	26: out = 6;
	27: out = 1;
	28: out = 4;
	default: out = 0;
	endcase
	end
endmodule

module sub_mod_15 (in1, in2, out);
	input [3:0] in1, in2;
	output [3:0] out;
	wire [4:0] data;

	assign data = 15 + in1 - in2;
	mod_15_29 mdval(data, out);
endmodule

module mod_15_29 (in, out);
	input [4:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
	// we have small max value so we can use table here
	case (in)
		0: out = 0;
		1: out = 1;
		2: out = 2;
		3: out = 3;
		4: out = 4;
		5: out = 5;
		6: out = 6;
		7: out = 7;
		8: out = 8;
		9: out = 9;
		10: out = 10;
		11: out = 11;
		12: out = 12;
		13: out = 13;
		14: out = 14;
		15: out = 0;
		16: out = 1;
		17: out = 2;
		18: out = 3;
		19: out = 4;
		20: out = 5;
		21: out = 6;
		22: out = 7;
		23: out = 8;
		24: out = 9;
		25: out = 10;
		26: out = 11;
		27: out = 12;
		28: out = 13;
		29: out = 14;
		default: out = 0;
	endcase
	end
endmodule