module multiplication_mod_31(inp1, inp2, out);
	input [4:0] inp1;
	input [4:0] inp2;
	output [4:0] out;
	wire [5:0] plus;
	wire [5:0] minus;
	wire [4:0] plout;
	wire [4:0] miout;
	assign plus = inp1 + inp2; // [0; 60]
	assign minus = 30 + inp1 - inp2; // [0; 60]
	lut_sqr_sum ls1(plus, plout);
	lut_sqr_sub ls2(minus, miout);
	sub_mod_31 sub1(plout, miout, out);
endmodule

module lut_sqr_sum (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
	case (in)
	0: out = 0;
	1: out = 8;
	2: out = 1;
	3: out = 10;
	4: out = 4;
	5: out = 14;
	6: out = 9;
	7: out = 20;
	8: out = 16;
	9: out = 28;
	10: out = 25;
	11: out = 7;
	12: out = 5;
	13: out = 19;
	14: out = 18;
	15: out = 2;
	16: out = 2;
	17: out = 18;
	18: out = 19;
	19: out = 5;
	20: out = 7;
	21: out = 25;
	22: out = 28;
	23: out = 16;
	24: out = 20;
	25: out = 9;
	26: out = 14;
	27: out = 4;
	28: out = 10;
	29: out = 1;
	30: out = 8;
	31: out = 0;
	32: out = 8;
	33: out = 1;
	34: out = 10;
	35: out = 4;
	36: out = 14;
	37: out = 9;
	38: out = 20;
	39: out = 16;
	40: out = 28;
	41: out = 25;
	42: out = 7;
	43: out = 5;
	44: out = 19;
	45: out = 18;
	46: out = 2;
	47: out = 2;
	48: out = 18;
	49: out = 19;
	50: out = 5;
	51: out = 7;
	52: out = 25;
	53: out = 28;
	54: out = 16;
	55: out = 20;
	56: out = 9;
	57: out = 14;
	58: out = 4;
	59: out = 10;
	60: out = 1;
	default: out = 0;
	endcase
	end
endmodule

module lut_sqr_sub (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
	case (in)
	0: out = 8;
	1: out = 1;
	2: out = 10;
	3: out = 4;
	4: out = 14;
	5: out = 9;
	6: out = 20;
	7: out = 16;
	8: out = 28;
	9: out = 25;
	10: out = 7;
	11: out = 5;
	12: out = 19;
	13: out = 18;
	14: out = 2;
	15: out = 2;
	16: out = 18;
	17: out = 19;
	18: out = 5;
	19: out = 7;
	20: out = 25;
	21: out = 28;
	22: out = 16;
	23: out = 20;
	24: out = 9;
	25: out = 14;
	26: out = 4;
	27: out = 10;
	28: out = 1;
	29: out = 8;
	30: out = 0;
	31: out = 8;
	32: out = 1;
	33: out = 10;
	34: out = 4;
	35: out = 14;
	36: out = 9;
	37: out = 20;
	38: out = 16;
	39: out = 28;
	40: out = 25;
	41: out = 7;
	42: out = 5;
	43: out = 19;
	44: out = 18;
	45: out = 2;
	46: out = 2;
	47: out = 18;
	48: out = 19;
	49: out = 5;
	50: out = 7;
	51: out = 25;
	52: out = 28;
	53: out = 16;
	54: out = 20;
	55: out = 9;
	56: out = 14;
	57: out = 4;
	58: out = 10;
	59: out = 1;
	60: out = 8;
	default: out = 0;
	endcase
	end
endmodule

module sub_mod_31 (in1, in2, out);
	input [4:0] in1, in2;
	output [4:0] out;
	wire [5:0] data;

	assign data = 31 + in1 - in2;
	mod_31_61 mdval(data, out);
endmodule

module mod_31_61 (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
	// we have small max value so we can use table here
	case (in)
		0: out = 0;
		1: out = 1;
		2: out = 2;
		3: out = 3;
		4: out = 4;
		5: out = 5;
		6: out = 6;
		7: out = 7;
		8: out = 8;
		9: out = 9;
		10: out = 10;
		11: out = 11;
		12: out = 12;
		13: out = 13;
		14: out = 14;
		15: out = 15;
		16: out = 16;
		17: out = 17;
		18: out = 18;
		19: out = 19;
		20: out = 20;
		21: out = 21;
		22: out = 22;
		23: out = 23;
		24: out = 24;
		25: out = 25;
		26: out = 26;
		27: out = 27;
		28: out = 28;
		29: out = 29;
		30: out = 30;
		31: out = 0;
		32: out = 1;
		33: out = 2;
		34: out = 3;
		35: out = 4;
		36: out = 5;
		37: out = 6;
		38: out = 7;
		39: out = 8;
		40: out = 9;
		41: out = 10;
		42: out = 11;
		43: out = 12;
		44: out = 13;
		45: out = 14;
		46: out = 15;
		47: out = 16;
		48: out = 17;
		49: out = 18;
		50: out = 19;
		51: out = 20;
		52: out = 21;
		53: out = 22;
		54: out = 23;
		55: out = 24;
		56: out = 25;
		57: out = 26;
		58: out = 27;
		59: out = 28;
		60: out = 29;
		61: out = 30;
		default: out = 0;
	endcase
	end
endmodule