module multiplication_mod_63(inp1, inp2, out);
	input [5:0] inp1;
	input [5:0] inp2;
	output [5:0] out;
	wire [6:0] plus;
	wire [6:0] minus;
	wire [5:0] plout;
	wire [5:0] miout;
	assign plus = inp1 + inp2; // [0; 124]
	assign minus = 62 + inp1 - inp2; // [0; 124]
	lut_sqr_sum ls1(plus, plout);
	lut_sqr_sub ls2(minus, miout);
	sub_mod_63 sub1(plout, miout, out);
endmodule

module lut_sqr_sum (in, out);
	input [6:0] in;
	output reg [5:0] out;
	always @ (in)
	begin
	case (in)
	0: out = 0;
	1: out = 16;
	2: out = 1;
	3: out = 18;
	4: out = 4;
	5: out = 22;
	6: out = 9;
	7: out = 28;
	8: out = 16;
	9: out = 36;
	10: out = 25;
	11: out = 46;
	12: out = 36;
	13: out = 58;
	14: out = 49;
	15: out = 9;
	16: out = 1;
	17: out = 25;
	18: out = 18;
	19: out = 43;
	20: out = 37;
	21: out = 0;
	22: out = 58;
	23: out = 22;
	24: out = 18;
	25: out = 46;
	26: out = 43;
	27: out = 9;
	28: out = 7;
	29: out = 37;
	30: out = 36;
	31: out = 4;
	32: out = 4;
	33: out = 36;
	34: out = 37;
	35: out = 7;
	36: out = 9;
	37: out = 43;
	38: out = 46;
	39: out = 18;
	40: out = 22;
	41: out = 58;
	42: out = 0;
	43: out = 37;
	44: out = 43;
	45: out = 18;
	46: out = 25;
	47: out = 1;
	48: out = 9;
	49: out = 49;
	50: out = 58;
	51: out = 36;
	52: out = 46;
	53: out = 25;
	54: out = 36;
	55: out = 16;
	56: out = 28;
	57: out = 9;
	58: out = 22;
	59: out = 4;
	60: out = 18;
	61: out = 1;
	62: out = 16;
	63: out = 0;
	64: out = 16;
	65: out = 1;
	66: out = 18;
	67: out = 4;
	68: out = 22;
	69: out = 9;
	70: out = 28;
	71: out = 16;
	72: out = 36;
	73: out = 25;
	74: out = 46;
	75: out = 36;
	76: out = 58;
	77: out = 49;
	78: out = 9;
	79: out = 1;
	80: out = 25;
	81: out = 18;
	82: out = 43;
	83: out = 37;
	84: out = 0;
	85: out = 58;
	86: out = 22;
	87: out = 18;
	88: out = 46;
	89: out = 43;
	90: out = 9;
	91: out = 7;
	92: out = 37;
	93: out = 36;
	94: out = 4;
	95: out = 4;
	96: out = 36;
	97: out = 37;
	98: out = 7;
	99: out = 9;
	100: out = 43;
	101: out = 46;
	102: out = 18;
	103: out = 22;
	104: out = 58;
	105: out = 0;
	106: out = 37;
	107: out = 43;
	108: out = 18;
	109: out = 25;
	110: out = 1;
	111: out = 9;
	112: out = 49;
	113: out = 58;
	114: out = 36;
	115: out = 46;
	116: out = 25;
	117: out = 36;
	118: out = 16;
	119: out = 28;
	120: out = 9;
	121: out = 22;
	122: out = 4;
	123: out = 18;
	124: out = 1;
	default: out = 0;
	endcase
	end
endmodule

module lut_sqr_sub (in, out);
	input [6:0] in;
	output reg [5:0] out;
	always @ (in)
	begin
	case (in)
	0: out = 16;
	1: out = 1;
	2: out = 18;
	3: out = 4;
	4: out = 22;
	5: out = 9;
	6: out = 28;
	7: out = 16;
	8: out = 36;
	9: out = 25;
	10: out = 46;
	11: out = 36;
	12: out = 58;
	13: out = 49;
	14: out = 9;
	15: out = 1;
	16: out = 25;
	17: out = 18;
	18: out = 43;
	19: out = 37;
	20: out = 0;
	21: out = 58;
	22: out = 22;
	23: out = 18;
	24: out = 46;
	25: out = 43;
	26: out = 9;
	27: out = 7;
	28: out = 37;
	29: out = 36;
	30: out = 4;
	31: out = 4;
	32: out = 36;
	33: out = 37;
	34: out = 7;
	35: out = 9;
	36: out = 43;
	37: out = 46;
	38: out = 18;
	39: out = 22;
	40: out = 58;
	41: out = 0;
	42: out = 37;
	43: out = 43;
	44: out = 18;
	45: out = 25;
	46: out = 1;
	47: out = 9;
	48: out = 49;
	49: out = 58;
	50: out = 36;
	51: out = 46;
	52: out = 25;
	53: out = 36;
	54: out = 16;
	55: out = 28;
	56: out = 9;
	57: out = 22;
	58: out = 4;
	59: out = 18;
	60: out = 1;
	61: out = 16;
	62: out = 0;
	63: out = 16;
	64: out = 1;
	65: out = 18;
	66: out = 4;
	67: out = 22;
	68: out = 9;
	69: out = 28;
	70: out = 16;
	71: out = 36;
	72: out = 25;
	73: out = 46;
	74: out = 36;
	75: out = 58;
	76: out = 49;
	77: out = 9;
	78: out = 1;
	79: out = 25;
	80: out = 18;
	81: out = 43;
	82: out = 37;
	83: out = 0;
	84: out = 58;
	85: out = 22;
	86: out = 18;
	87: out = 46;
	88: out = 43;
	89: out = 9;
	90: out = 7;
	91: out = 37;
	92: out = 36;
	93: out = 4;
	94: out = 4;
	95: out = 36;
	96: out = 37;
	97: out = 7;
	98: out = 9;
	99: out = 43;
	100: out = 46;
	101: out = 18;
	102: out = 22;
	103: out = 58;
	104: out = 0;
	105: out = 37;
	106: out = 43;
	107: out = 18;
	108: out = 25;
	109: out = 1;
	110: out = 9;
	111: out = 49;
	112: out = 58;
	113: out = 36;
	114: out = 46;
	115: out = 25;
	116: out = 36;
	117: out = 16;
	118: out = 28;
	119: out = 9;
	120: out = 22;
	121: out = 4;
	122: out = 18;
	123: out = 1;
	124: out = 16;
	default: out = 0;
	endcase
	end
endmodule

module sub_mod_63 (in1, in2, out);
	input [5:0] in1, in2;
	output [5:0] out;
	wire [6:0] data;

	assign data = 63 + in1 - in2;
	mod_63_125 mdval(data, out);
endmodule

module mod_63_125 (in, out);
	input [6:0] in;
	output reg [5:0] out;
	always @ (in)
	begin
		if (in < 63)
		begin
			out = in;
		end
		else
		begin
			out = in - 63;
		end
	end
endmodule