module multiplication_mod_127(inp1, inp2, out);
	input [6:0] inp1;
	input [6:0] inp2;
	output reg [6:0] out;
	wire [6:0] out_pre;
	wire [1:0] w_1_0;
	wire [1:0] w_2_0;
	wire [1:0] wout_0;
	wire [3:0] w_1_1;
	wire [3:0] w_2_1;
	wire [3:0] wout_1;
	wire [2:0] w_1_2;
	wire [2:0] w_2_2;
	wire [2:0] wout_2;
	lut_input_127 lut1(inp1, w_1_0, w_1_1, w_1_2);
	lut_input_127 lut2(inp2, w_2_0, w_2_1, w_2_2);
	sum_modulo_2 sm0(w_1_0, w_2_0, wout_0);
	sum_modulo_9 sm1(w_1_1, w_2_1, wout_1);
	sum_modulo_7 sm2(w_1_2, w_2_2, wout_2);
	lut_output_127 lut3(wout_0, wout_1, wout_2, out_pre);
	always @ (*)
	begin
		if (inp1 == 0 || inp2 == 0)
		begin
			out = 0;
		end
		else
		begin
			out = out_pre;
		end
	end
endmodule

module sum_modulo_2(inp1, inp2, out);
	input [1:0] inp1;
	input [1:0] inp2;
	output reg [1:0] out;
	wire [2:0] int;
	assign int = inp1 + inp2;
	always @ (*)
	begin
		if (int < 2)
		begin
			out = int;
		end
		else
		begin
			out = int - 2;
		end
	end
endmodule

module sum_modulo_9(inp1, inp2, out);
	input [3:0] inp1;
	input [3:0] inp2;
	output reg [3:0] out;
	wire [4:0] int;
	assign int = inp1 + inp2;
	always @ (*)
	begin
		if (int < 9)
		begin
			out = int;
		end
		else
		begin
			out = int - 9;
		end
	end
endmodule

module sum_modulo_7(inp1, inp2, out);
	input [2:0] inp1;
	input [2:0] inp2;
	output reg [2:0] out;
	wire [3:0] int;
	assign int = inp1 + inp2;
	always @ (*)
	begin
		if (int < 7)
		begin
			out = int;
		end
		else
		begin
			out = int - 7;
		end
	end
endmodule

module lut_output_127(inp0, inp1, inp2, out);
	output reg [6:0] out;
	input [1:0] inp0;
	input [3:0] inp1;
	input [2:0] inp2;
	always @ (*)
	begin
		if (inp0 == 0 && inp1 == 0 && inp2 == 0)
		begin
			out <= 1;
		end
		else if (inp0 == 0 && inp1 == 0 && inp2 == 2)
		begin
			out <= 2;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 1)
		begin
			out <= 3;
		end
		else if (inp0 == 0 && inp1 == 0 && inp2 == 4)
		begin
			out <= 4;
		end
		else if (inp0 == 1 && inp1 == 6 && inp2 == 3)
		begin
			out <= 5;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 3)
		begin
			out <= 6;
		end
		else if (inp0 == 1 && inp1 == 7 && inp2 == 3)
		begin
			out <= 7;
		end
		else if (inp0 == 0 && inp1 == 0 && inp2 == 6)
		begin
			out <= 8;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 2)
		begin
			out <= 9;
		end
		else if (inp0 == 1 && inp1 == 6 && inp2 == 5)
		begin
			out <= 10;
		end
		else if (inp0 == 0 && inp1 == 5 && inp2 == 5)
		begin
			out <= 11;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 5)
		begin
			out <= 12;
		end
		else if (inp0 == 0 && inp1 == 4 && inp2 == 3)
		begin
			out <= 13;
		end
		else if (inp0 == 1 && inp1 == 7 && inp2 == 5)
		begin
			out <= 14;
		end
		else if (inp0 == 0 && inp1 == 7 && inp2 == 4)
		begin
			out <= 15;
		end
		else if (inp0 == 0 && inp1 == 0 && inp2 == 1)
		begin
			out <= 16;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 3)
		begin
			out <= 17;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 4)
		begin
			out <= 18;
		end
		else if (inp0 == 0 && inp1 == 3 && inp2 == 0)
		begin
			out <= 19;
		end
		else if (inp0 == 1 && inp1 == 6 && inp2 == 0)
		begin
			out <= 20;
		end
		else if (inp0 == 0 && inp1 == 8 && inp2 == 4)
		begin
			out <= 21;
		end
		else if (inp0 == 0 && inp1 == 5 && inp2 == 0)
		begin
			out <= 22;
		end
		else if (inp0 == 1 && inp1 == 4 && inp2 == 2)
		begin
			out <= 23;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 0)
		begin
			out <= 24;
		end
		else if (inp0 == 0 && inp1 == 3 && inp2 == 6)
		begin
			out <= 25;
		end
		else if (inp0 == 0 && inp1 == 4 && inp2 == 5)
		begin
			out <= 26;
		end
		else if (inp0 == 1 && inp1 == 3 && inp2 == 3)
		begin
			out <= 27;
		end
		else if (inp0 == 1 && inp1 == 7 && inp2 == 0)
		begin
			out <= 28;
		end
		else if (inp0 == 1 && inp1 == 5 && inp2 == 1)
		begin
			out <= 29;
		end
		else if (inp0 == 0 && inp1 == 7 && inp2 == 6)
		begin
			out <= 30;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 4)
		begin
			out <= 31;
		end
		else if (inp0 == 0 && inp1 == 0 && inp2 == 3)
		begin
			out <= 32;
		end
		else if (inp0 == 1 && inp1 == 6 && inp2 == 6)
		begin
			out <= 33;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 5)
		begin
			out <= 34;
		end
		else if (inp0 == 0 && inp1 == 4 && inp2 == 6)
		begin
			out <= 35;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 6)
		begin
			out <= 36;
		end
		else if (inp0 == 0 && inp1 == 8 && inp2 == 0)
		begin
			out <= 37;
		end
		else if (inp0 == 0 && inp1 == 3 && inp2 == 2)
		begin
			out <= 38;
		end
		else if (inp0 == 1 && inp1 == 5 && inp2 == 4)
		begin
			out <= 39;
		end
		else if (inp0 == 1 && inp1 == 6 && inp2 == 2)
		begin
			out <= 40;
		end
		else if (inp0 == 0 && inp1 == 8 && inp2 == 3)
		begin
			out <= 41;
		end
		else if (inp0 == 0 && inp1 == 8 && inp2 == 6)
		begin
			out <= 42;
		end
		else if (inp0 == 1 && inp1 == 8 && inp2 == 1)
		begin
			out <= 43;
		end
		else if (inp0 == 0 && inp1 == 5 && inp2 == 2)
		begin
			out <= 44;
		end
		else if (inp0 == 1 && inp1 == 8 && inp2 == 5)
		begin
			out <= 45;
		end
		else if (inp0 == 1 && inp1 == 4 && inp2 == 4)
		begin
			out <= 46;
		end
		else if (inp0 == 0 && inp1 == 6 && inp2 == 4)
		begin
			out <= 47;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 2)
		begin
			out <= 48;
		end
		else if (inp0 == 0 && inp1 == 5 && inp2 == 6)
		begin
			out <= 49;
		end
		else if (inp0 == 0 && inp1 == 3 && inp2 == 1)
		begin
			out <= 50;
		end
		else if (inp0 == 1 && inp1 == 3 && inp2 == 4)
		begin
			out <= 51;
		end
		else if (inp0 == 0 && inp1 == 4 && inp2 == 0)
		begin
			out <= 52;
		end
		else if (inp0 == 1 && inp1 == 8 && inp2 == 2)
		begin
			out <= 53;
		end
		else if (inp0 == 1 && inp1 == 3 && inp2 == 5)
		begin
			out <= 54;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 1)
		begin
			out <= 55;
		end
		else if (inp0 == 1 && inp1 == 7 && inp2 == 2)
		begin
			out <= 56;
		end
		else if (inp0 == 1 && inp1 == 4 && inp2 == 1)
		begin
			out <= 57;
		end
		else if (inp0 == 1 && inp1 == 5 && inp2 == 3)
		begin
			out <= 58;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 0)
		begin
			out <= 59;
		end
		else if (inp0 == 0 && inp1 == 7 && inp2 == 1)
		begin
			out <= 60;
		end
		else if (inp0 == 0 && inp1 == 6 && inp2 == 1)
		begin
			out <= 61;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 6)
		begin
			out <= 62;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 5)
		begin
			out <= 63;
		end
		else if (inp0 == 0 && inp1 == 0 && inp2 == 5)
		begin
			out <= 64;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 6)
		begin
			out <= 65;
		end
		else if (inp0 == 1 && inp1 == 6 && inp2 == 1)
		begin
			out <= 66;
		end
		else if (inp0 == 1 && inp1 == 7 && inp2 == 1)
		begin
			out <= 67;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 0)
		begin
			out <= 68;
		end
		else if (inp0 == 0 && inp1 == 5 && inp2 == 3)
		begin
			out <= 69;
		end
		else if (inp0 == 0 && inp1 == 4 && inp2 == 1)
		begin
			out <= 70;
		end
		else if (inp0 == 0 && inp1 == 7 && inp2 == 2)
		begin
			out <= 71;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 1)
		begin
			out <= 72;
		end
		else if (inp0 == 0 && inp1 == 3 && inp2 == 5)
		begin
			out <= 73;
		end
		else if (inp0 == 0 && inp1 == 8 && inp2 == 2)
		begin
			out <= 74;
		end
		else if (inp0 == 1 && inp1 == 4 && inp2 == 0)
		begin
			out <= 75;
		end
		else if (inp0 == 0 && inp1 == 3 && inp2 == 4)
		begin
			out <= 76;
		end
		else if (inp0 == 1 && inp1 == 3 && inp2 == 1)
		begin
			out <= 77;
		end
		else if (inp0 == 1 && inp1 == 5 && inp2 == 6)
		begin
			out <= 78;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 2)
		begin
			out <= 79;
		end
		else if (inp0 == 1 && inp1 == 6 && inp2 == 4)
		begin
			out <= 80;
		end
		else if (inp0 == 0 && inp1 == 4 && inp2 == 4)
		begin
			out <= 81;
		end
		else if (inp0 == 0 && inp1 == 8 && inp2 == 5)
		begin
			out <= 82;
		end
		else if (inp0 == 1 && inp1 == 5 && inp2 == 2)
		begin
			out <= 83;
		end
		else if (inp0 == 0 && inp1 == 8 && inp2 == 1)
		begin
			out <= 84;
		end
		else if (inp0 == 1 && inp1 == 8 && inp2 == 6)
		begin
			out <= 85;
		end
		else if (inp0 == 1 && inp1 == 8 && inp2 == 3)
		begin
			out <= 86;
		end
		else if (inp0 == 0 && inp1 == 6 && inp2 == 2)
		begin
			out <= 87;
		end
		else if (inp0 == 0 && inp1 == 5 && inp2 == 4)
		begin
			out <= 88;
		end
		else if (inp0 == 1 && inp1 == 3 && inp2 == 2)
		begin
			out <= 89;
		end
		else if (inp0 == 1 && inp1 == 8 && inp2 == 0)
		begin
			out <= 90;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 6)
		begin
			out <= 91;
		end
		else if (inp0 == 1 && inp1 == 4 && inp2 == 6)
		begin
			out <= 92;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 5)
		begin
			out <= 93;
		end
		else if (inp0 == 0 && inp1 == 6 && inp2 == 6)
		begin
			out <= 94;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 3)
		begin
			out <= 95;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 4)
		begin
			out <= 96;
		end
		else if (inp0 == 1 && inp1 == 7 && inp2 == 6)
		begin
			out <= 97;
		end
		else if (inp0 == 0 && inp1 == 5 && inp2 == 1)
		begin
			out <= 98;
		end
		else if (inp0 == 0 && inp1 == 7 && inp2 == 0)
		begin
			out <= 99;
		end
		else if (inp0 == 0 && inp1 == 3 && inp2 == 3)
		begin
			out <= 100;
		end
		else if (inp0 == 1 && inp1 == 4 && inp2 == 5)
		begin
			out <= 101;
		end
		else if (inp0 == 1 && inp1 == 3 && inp2 == 6)
		begin
			out <= 102;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 0)
		begin
			out <= 103;
		end
		else if (inp0 == 0 && inp1 == 4 && inp2 == 2)
		begin
			out <= 104;
		end
		else if (inp0 == 1 && inp1 == 5 && inp2 == 0)
		begin
			out <= 105;
		end
		else if (inp0 == 1 && inp1 == 8 && inp2 == 4)
		begin
			out <= 106;
		end
		else if (inp0 == 0 && inp1 == 6 && inp2 == 0)
		begin
			out <= 107;
		end
		else if (inp0 == 1 && inp1 == 3 && inp2 == 0)
		begin
			out <= 108;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 4)
		begin
			out <= 109;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 3)
		begin
			out <= 110;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 1)
		begin
			out <= 111;
		end
		else if (inp0 == 1 && inp1 == 7 && inp2 == 4)
		begin
			out <= 112;
		end
		else if (inp0 == 0 && inp1 == 7 && inp2 == 5)
		begin
			out <= 113;
		end
		else if (inp0 == 1 && inp1 == 4 && inp2 == 3)
		begin
			out <= 114;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 5)
		begin
			out <= 115;
		end
		else if (inp0 == 1 && inp1 == 5 && inp2 == 5)
		begin
			out <= 116;
		end
		else if (inp0 == 0 && inp1 == 6 && inp2 == 5)
		begin
			out <= 117;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 2)
		begin
			out <= 118;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 6)
		begin
			out <= 119;
		end
		else if (inp0 == 0 && inp1 == 7 && inp2 == 3)
		begin
			out <= 120;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 3)
		begin
			out <= 121;
		end
		else if (inp0 == 0 && inp1 == 6 && inp2 == 3)
		begin
			out <= 122;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 4)
		begin
			out <= 123;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 1)
		begin
			out <= 124;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 2)
		begin
			out <= 125;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 0)
		begin
			out <= 126;
		end
		else 
		begin
			out <= 0;
		end
	end
endmodule

module lut_input_127(inp, out0, out1, out2);
	input [6:0] inp;
	output reg [1:0] out0;
	output reg [3:0] out1;
	output reg [2:0] out2;
	always @ (inp)
	begin
		case(inp)
		1:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 0;
		end
		2:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 2;
		end
		3:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 1;
		end
		4:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 4;
		end
		5:
		begin
			out0 <= 1;
			out1 <= 6;
			out2 <= 3;
		end
		6:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 3;
		end
		7:
		begin
			out0 <= 1;
			out1 <= 7;
			out2 <= 3;
		end
		8:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 6;
		end
		9:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 2;
		end
		10:
		begin
			out0 <= 1;
			out1 <= 6;
			out2 <= 5;
		end
		11:
		begin
			out0 <= 0;
			out1 <= 5;
			out2 <= 5;
		end
		12:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 5;
		end
		13:
		begin
			out0 <= 0;
			out1 <= 4;
			out2 <= 3;
		end
		14:
		begin
			out0 <= 1;
			out1 <= 7;
			out2 <= 5;
		end
		15:
		begin
			out0 <= 0;
			out1 <= 7;
			out2 <= 4;
		end
		16:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 1;
		end
		17:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 3;
		end
		18:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 4;
		end
		19:
		begin
			out0 <= 0;
			out1 <= 3;
			out2 <= 0;
		end
		20:
		begin
			out0 <= 1;
			out1 <= 6;
			out2 <= 0;
		end
		21:
		begin
			out0 <= 0;
			out1 <= 8;
			out2 <= 4;
		end
		22:
		begin
			out0 <= 0;
			out1 <= 5;
			out2 <= 0;
		end
		23:
		begin
			out0 <= 1;
			out1 <= 4;
			out2 <= 2;
		end
		24:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 0;
		end
		25:
		begin
			out0 <= 0;
			out1 <= 3;
			out2 <= 6;
		end
		26:
		begin
			out0 <= 0;
			out1 <= 4;
			out2 <= 5;
		end
		27:
		begin
			out0 <= 1;
			out1 <= 3;
			out2 <= 3;
		end
		28:
		begin
			out0 <= 1;
			out1 <= 7;
			out2 <= 0;
		end
		29:
		begin
			out0 <= 1;
			out1 <= 5;
			out2 <= 1;
		end
		30:
		begin
			out0 <= 0;
			out1 <= 7;
			out2 <= 6;
		end
		31:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 4;
		end
		32:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 3;
		end
		33:
		begin
			out0 <= 1;
			out1 <= 6;
			out2 <= 6;
		end
		34:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 5;
		end
		35:
		begin
			out0 <= 0;
			out1 <= 4;
			out2 <= 6;
		end
		36:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 6;
		end
		37:
		begin
			out0 <= 0;
			out1 <= 8;
			out2 <= 0;
		end
		38:
		begin
			out0 <= 0;
			out1 <= 3;
			out2 <= 2;
		end
		39:
		begin
			out0 <= 1;
			out1 <= 5;
			out2 <= 4;
		end
		40:
		begin
			out0 <= 1;
			out1 <= 6;
			out2 <= 2;
		end
		41:
		begin
			out0 <= 0;
			out1 <= 8;
			out2 <= 3;
		end
		42:
		begin
			out0 <= 0;
			out1 <= 8;
			out2 <= 6;
		end
		43:
		begin
			out0 <= 1;
			out1 <= 8;
			out2 <= 1;
		end
		44:
		begin
			out0 <= 0;
			out1 <= 5;
			out2 <= 2;
		end
		45:
		begin
			out0 <= 1;
			out1 <= 8;
			out2 <= 5;
		end
		46:
		begin
			out0 <= 1;
			out1 <= 4;
			out2 <= 4;
		end
		47:
		begin
			out0 <= 0;
			out1 <= 6;
			out2 <= 4;
		end
		48:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 2;
		end
		49:
		begin
			out0 <= 0;
			out1 <= 5;
			out2 <= 6;
		end
		50:
		begin
			out0 <= 0;
			out1 <= 3;
			out2 <= 1;
		end
		51:
		begin
			out0 <= 1;
			out1 <= 3;
			out2 <= 4;
		end
		52:
		begin
			out0 <= 0;
			out1 <= 4;
			out2 <= 0;
		end
		53:
		begin
			out0 <= 1;
			out1 <= 8;
			out2 <= 2;
		end
		54:
		begin
			out0 <= 1;
			out1 <= 3;
			out2 <= 5;
		end
		55:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 1;
		end
		56:
		begin
			out0 <= 1;
			out1 <= 7;
			out2 <= 2;
		end
		57:
		begin
			out0 <= 1;
			out1 <= 4;
			out2 <= 1;
		end
		58:
		begin
			out0 <= 1;
			out1 <= 5;
			out2 <= 3;
		end
		59:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 0;
		end
		60:
		begin
			out0 <= 0;
			out1 <= 7;
			out2 <= 1;
		end
		61:
		begin
			out0 <= 0;
			out1 <= 6;
			out2 <= 1;
		end
		62:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 6;
		end
		63:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 5;
		end
		64:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 5;
		end
		65:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 6;
		end
		66:
		begin
			out0 <= 1;
			out1 <= 6;
			out2 <= 1;
		end
		67:
		begin
			out0 <= 1;
			out1 <= 7;
			out2 <= 1;
		end
		68:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 0;
		end
		69:
		begin
			out0 <= 0;
			out1 <= 5;
			out2 <= 3;
		end
		70:
		begin
			out0 <= 0;
			out1 <= 4;
			out2 <= 1;
		end
		71:
		begin
			out0 <= 0;
			out1 <= 7;
			out2 <= 2;
		end
		72:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 1;
		end
		73:
		begin
			out0 <= 0;
			out1 <= 3;
			out2 <= 5;
		end
		74:
		begin
			out0 <= 0;
			out1 <= 8;
			out2 <= 2;
		end
		75:
		begin
			out0 <= 1;
			out1 <= 4;
			out2 <= 0;
		end
		76:
		begin
			out0 <= 0;
			out1 <= 3;
			out2 <= 4;
		end
		77:
		begin
			out0 <= 1;
			out1 <= 3;
			out2 <= 1;
		end
		78:
		begin
			out0 <= 1;
			out1 <= 5;
			out2 <= 6;
		end
		79:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 2;
		end
		80:
		begin
			out0 <= 1;
			out1 <= 6;
			out2 <= 4;
		end
		81:
		begin
			out0 <= 0;
			out1 <= 4;
			out2 <= 4;
		end
		82:
		begin
			out0 <= 0;
			out1 <= 8;
			out2 <= 5;
		end
		83:
		begin
			out0 <= 1;
			out1 <= 5;
			out2 <= 2;
		end
		84:
		begin
			out0 <= 0;
			out1 <= 8;
			out2 <= 1;
		end
		85:
		begin
			out0 <= 1;
			out1 <= 8;
			out2 <= 6;
		end
		86:
		begin
			out0 <= 1;
			out1 <= 8;
			out2 <= 3;
		end
		87:
		begin
			out0 <= 0;
			out1 <= 6;
			out2 <= 2;
		end
		88:
		begin
			out0 <= 0;
			out1 <= 5;
			out2 <= 4;
		end
		89:
		begin
			out0 <= 1;
			out1 <= 3;
			out2 <= 2;
		end
		90:
		begin
			out0 <= 1;
			out1 <= 8;
			out2 <= 0;
		end
		91:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 6;
		end
		92:
		begin
			out0 <= 1;
			out1 <= 4;
			out2 <= 6;
		end
		93:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 5;
		end
		94:
		begin
			out0 <= 0;
			out1 <= 6;
			out2 <= 6;
		end
		95:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 3;
		end
		96:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 4;
		end
		97:
		begin
			out0 <= 1;
			out1 <= 7;
			out2 <= 6;
		end
		98:
		begin
			out0 <= 0;
			out1 <= 5;
			out2 <= 1;
		end
		99:
		begin
			out0 <= 0;
			out1 <= 7;
			out2 <= 0;
		end
		100:
		begin
			out0 <= 0;
			out1 <= 3;
			out2 <= 3;
		end
		101:
		begin
			out0 <= 1;
			out1 <= 4;
			out2 <= 5;
		end
		102:
		begin
			out0 <= 1;
			out1 <= 3;
			out2 <= 6;
		end
		103:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 0;
		end
		104:
		begin
			out0 <= 0;
			out1 <= 4;
			out2 <= 2;
		end
		105:
		begin
			out0 <= 1;
			out1 <= 5;
			out2 <= 0;
		end
		106:
		begin
			out0 <= 1;
			out1 <= 8;
			out2 <= 4;
		end
		107:
		begin
			out0 <= 0;
			out1 <= 6;
			out2 <= 0;
		end
		108:
		begin
			out0 <= 1;
			out1 <= 3;
			out2 <= 0;
		end
		109:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 4;
		end
		110:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 3;
		end
		111:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 1;
		end
		112:
		begin
			out0 <= 1;
			out1 <= 7;
			out2 <= 4;
		end
		113:
		begin
			out0 <= 0;
			out1 <= 7;
			out2 <= 5;
		end
		114:
		begin
			out0 <= 1;
			out1 <= 4;
			out2 <= 3;
		end
		115:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 5;
		end
		116:
		begin
			out0 <= 1;
			out1 <= 5;
			out2 <= 5;
		end
		117:
		begin
			out0 <= 0;
			out1 <= 6;
			out2 <= 5;
		end
		118:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 2;
		end
		119:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 6;
		end
		120:
		begin
			out0 <= 0;
			out1 <= 7;
			out2 <= 3;
		end
		121:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 3;
		end
		122:
		begin
			out0 <= 0;
			out1 <= 6;
			out2 <= 3;
		end
		123:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 4;
		end
		124:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 1;
		end
		125:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 2;
		end
		126:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 0;
		end
		default:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 0;
		end
		endcase
	end
endmodule