module multiplication_mod_251(inp1, inp2, out);
	input [7:0] inp1;
	input [7:0] inp2;
	output reg [7:0] out;
	wire [7:0] out_pre;
	wire [1:0] w_1_0;
	wire [1:0] w_2_0;
	wire [1:0] wout_0;
	wire [6:0] w_1_1;
	wire [6:0] w_2_1;
	wire [6:0] wout_1;
	lut_input_251 lut1(inp1, w_1_0, w_1_1);
	lut_input_251 lut2(inp2, w_2_0, w_2_1);
	sum_modulo_2 sm0(w_1_0, w_2_0, wout_0);
	sum_modulo_125 sm1(w_1_1, w_2_1, wout_1);
	lut_output_251 lut3(wout_0, wout_1, out_pre);
	always @ (*)
	begin
		if (inp1 == 0 || inp2 == 0)
		begin
			out = 0;
		end
		else
		begin
			out = out_pre;
		end
	end
endmodule

module sum_modulo_2(inp1, inp2, out);
	input [1:0] inp1;
	input [1:0] inp2;
	output reg [1:0] out;
	wire [2:0] int;
	assign int = inp1 + inp2;
	always @ (*)
	begin
		if (int < 2)
		begin
			out = int;
		end
		else
		begin
			out = int - 2;
		end
	end
endmodule

module sum_modulo_125(inp1, inp2, out);
	input [6:0] inp1;
	input [6:0] inp2;
	output reg [6:0] out;
	wire [7:0] int;
	assign int = inp1 + inp2;
	always @ (*)
	begin
		if (int < 125)
		begin
			out = int;
		end
		else
		begin
			out = int - 125;
		end
	end
endmodule

module lut_output_251(inp0, inp1, out);
	output reg [7:0] out;
	input [1:0] inp0;
	input [6:0] inp1;
	always @ (*)
	begin
		if (inp0 == 0 && inp1 == 0)
		begin
			out <= 1;
		end
		else if (inp0 == 1 && inp1 == 110)
		begin
			out <= 2;
		end
		else if (inp0 == 0 && inp1 == 16)
		begin
			out <= 3;
		end
		else if (inp0 == 0 && inp1 == 95)
		begin
			out <= 4;
		end
		else if (inp0 == 0 && inp1 == 5)
		begin
			out <= 5;
		end
		else if (inp0 == 1 && inp1 == 1)
		begin
			out <= 6;
		end
		else if (inp0 == 0 && inp1 == 123)
		begin
			out <= 7;
		end
		else if (inp0 == 1 && inp1 == 80)
		begin
			out <= 8;
		end
		else if (inp0 == 0 && inp1 == 32)
		begin
			out <= 9;
		end
		else if (inp0 == 1 && inp1 == 115)
		begin
			out <= 10;
		end
		else if (inp0 == 1 && inp1 == 86)
		begin
			out <= 11;
		end
		else if (inp0 == 0 && inp1 == 111)
		begin
			out <= 12;
		end
		else if (inp0 == 0 && inp1 == 57)
		begin
			out <= 13;
		end
		else if (inp0 == 1 && inp1 == 108)
		begin
			out <= 14;
		end
		else if (inp0 == 0 && inp1 == 21)
		begin
			out <= 15;
		end
		else if (inp0 == 0 && inp1 == 65)
		begin
			out <= 16;
		end
		else if (inp0 == 0 && inp1 == 74)
		begin
			out <= 17;
		end
		else if (inp0 == 1 && inp1 == 17)
		begin
			out <= 18;
		end
		else if (inp0 == 1 && inp1 == 38)
		begin
			out <= 19;
		end
		else if (inp0 == 0 && inp1 == 100)
		begin
			out <= 20;
		end
		else if (inp0 == 0 && inp1 == 14)
		begin
			out <= 21;
		end
		else if (inp0 == 0 && inp1 == 71)
		begin
			out <= 22;
		end
		else if (inp0 == 0 && inp1 == 24)
		begin
			out <= 23;
		end
		else if (inp0 == 1 && inp1 == 96)
		begin
			out <= 24;
		end
		else if (inp0 == 0 && inp1 == 10)
		begin
			out <= 25;
		end
		else if (inp0 == 1 && inp1 == 42)
		begin
			out <= 26;
		end
		else if (inp0 == 0 && inp1 == 48)
		begin
			out <= 27;
		end
		else if (inp0 == 0 && inp1 == 93)
		begin
			out <= 28;
		end
		else if (inp0 == 1 && inp1 == 83)
		begin
			out <= 29;
		end
		else if (inp0 == 1 && inp1 == 6)
		begin
			out <= 30;
		end
		else if (inp0 == 0 && inp1 == 61)
		begin
			out <= 31;
		end
		else if (inp0 == 1 && inp1 == 50)
		begin
			out <= 32;
		end
		else if (inp0 == 1 && inp1 == 102)
		begin
			out <= 33;
		end
		else if (inp0 == 1 && inp1 == 59)
		begin
			out <= 34;
		end
		else if (inp0 == 0 && inp1 == 3)
		begin
			out <= 35;
		end
		else if (inp0 == 0 && inp1 == 2)
		begin
			out <= 36;
		end
		else if (inp0 == 1 && inp1 == 82)
		begin
			out <= 37;
		end
		else if (inp0 == 0 && inp1 == 23)
		begin
			out <= 38;
		end
		else if (inp0 == 0 && inp1 == 73)
		begin
			out <= 39;
		end
		else if (inp0 == 1 && inp1 == 85)
		begin
			out <= 40;
		end
		else if (inp0 == 0 && inp1 == 4)
		begin
			out <= 41;
		end
		else if (inp0 == 1 && inp1 == 124)
		begin
			out <= 42;
		end
		else if (inp0 == 1 && inp1 == 122)
		begin
			out <= 43;
		end
		else if (inp0 == 1 && inp1 == 56)
		begin
			out <= 44;
		end
		else if (inp0 == 0 && inp1 == 37)
		begin
			out <= 45;
		end
		else if (inp0 == 1 && inp1 == 9)
		begin
			out <= 46;
		end
		else if (inp0 == 1 && inp1 == 60)
		begin
			out <= 47;
		end
		else if (inp0 == 0 && inp1 == 81)
		begin
			out <= 48;
		end
		else if (inp0 == 0 && inp1 == 121)
		begin
			out <= 49;
		end
		else if (inp0 == 1 && inp1 == 120)
		begin
			out <= 50;
		end
		else if (inp0 == 0 && inp1 == 90)
		begin
			out <= 51;
		end
		else if (inp0 == 0 && inp1 == 27)
		begin
			out <= 52;
		end
		else if (inp0 == 1 && inp1 == 103)
		begin
			out <= 53;
		end
		else if (inp0 == 1 && inp1 == 33)
		begin
			out <= 54;
		end
		else if (inp0 == 1 && inp1 == 91)
		begin
			out <= 55;
		end
		else if (inp0 == 1 && inp1 == 78)
		begin
			out <= 56;
		end
		else if (inp0 == 1 && inp1 == 54)
		begin
			out <= 57;
		end
		else if (inp0 == 0 && inp1 == 68)
		begin
			out <= 58;
		end
		else if (inp0 == 1 && inp1 == 51)
		begin
			out <= 59;
		end
		else if (inp0 == 0 && inp1 == 116)
		begin
			out <= 60;
		end
		else if (inp0 == 1 && inp1 == 28)
		begin
			out <= 61;
		end
		else if (inp0 == 1 && inp1 == 46)
		begin
			out <= 62;
		end
		else if (inp0 == 0 && inp1 == 30)
		begin
			out <= 63;
		end
		else if (inp0 == 0 && inp1 == 35)
		begin
			out <= 64;
		end
		else if (inp0 == 0 && inp1 == 62)
		begin
			out <= 65;
		end
		else if (inp0 == 0 && inp1 == 87)
		begin
			out <= 66;
		end
		else if (inp0 == 0 && inp1 == 104)
		begin
			out <= 67;
		end
		else if (inp0 == 0 && inp1 == 44)
		begin
			out <= 68;
		end
		else if (inp0 == 0 && inp1 == 40)
		begin
			out <= 69;
		end
		else if (inp0 == 1 && inp1 == 113)
		begin
			out <= 70;
		end
		else if (inp0 == 1 && inp1 == 7)
		begin
			out <= 71;
		end
		else if (inp0 == 1 && inp1 == 112)
		begin
			out <= 72;
		end
		else if (inp0 == 0 && inp1 == 34)
		begin
			out <= 73;
		end
		else if (inp0 == 0 && inp1 == 67)
		begin
			out <= 74;
		end
		else if (inp0 == 0 && inp1 == 26)
		begin
			out <= 75;
		end
		else if (inp0 == 1 && inp1 == 8)
		begin
			out <= 76;
		end
		else if (inp0 == 1 && inp1 == 84)
		begin
			out <= 77;
		end
		else if (inp0 == 1 && inp1 == 58)
		begin
			out <= 78;
		end
		else if (inp0 == 0 && inp1 == 92)
		begin
			out <= 79;
		end
		else if (inp0 == 0 && inp1 == 70)
		begin
			out <= 80;
		end
		else if (inp0 == 0 && inp1 == 64)
		begin
			out <= 81;
		end
		else if (inp0 == 1 && inp1 == 114)
		begin
			out <= 82;
		end
		else if (inp0 == 0 && inp1 == 94)
		begin
			out <= 83;
		end
		else if (inp0 == 0 && inp1 == 109)
		begin
			out <= 84;
		end
		else if (inp0 == 0 && inp1 == 79)
		begin
			out <= 85;
		end
		else if (inp0 == 0 && inp1 == 107)
		begin
			out <= 86;
		end
		else if (inp0 == 1 && inp1 == 99)
		begin
			out <= 87;
		end
		else if (inp0 == 0 && inp1 == 41)
		begin
			out <= 88;
		end
		else if (inp0 == 0 && inp1 == 49)
		begin
			out <= 89;
		end
		else if (inp0 == 1 && inp1 == 22)
		begin
			out <= 90;
		end
		else if (inp0 == 0 && inp1 == 55)
		begin
			out <= 91;
		end
		else if (inp0 == 0 && inp1 == 119)
		begin
			out <= 92;
		end
		else if (inp0 == 0 && inp1 == 77)
		begin
			out <= 93;
		end
		else if (inp0 == 0 && inp1 == 45)
		begin
			out <= 94;
		end
		else if (inp0 == 1 && inp1 == 43)
		begin
			out <= 95;
		end
		else if (inp0 == 1 && inp1 == 66)
		begin
			out <= 96;
		end
		else if (inp0 == 1 && inp1 == 69)
		begin
			out <= 97;
		end
		else if (inp0 == 1 && inp1 == 106)
		begin
			out <= 98;
		end
		else if (inp0 == 1 && inp1 == 118)
		begin
			out <= 99;
		end
		else if (inp0 == 0 && inp1 == 105)
		begin
			out <= 100;
		end
		else if (inp0 == 0 && inp1 == 11)
		begin
			out <= 101;
		end
		else if (inp0 == 1 && inp1 == 75)
		begin
			out <= 102;
		end
		else if (inp0 == 0 && inp1 == 52)
		begin
			out <= 103;
		end
		else if (inp0 == 1 && inp1 == 12)
		begin
			out <= 104;
		end
		else if (inp0 == 0 && inp1 == 19)
		begin
			out <= 105;
		end
		else if (inp0 == 0 && inp1 == 88)
		begin
			out <= 106;
		end
		else if (inp0 == 1 && inp1 == 97)
		begin
			out <= 107;
		end
		else if (inp0 == 0 && inp1 == 18)
		begin
			out <= 108;
		end
		else if (inp0 == 1 && inp1 == 117)
		begin
			out <= 109;
		end
		else if (inp0 == 0 && inp1 == 76)
		begin
			out <= 110;
		end
		else if (inp0 == 1 && inp1 == 98)
		begin
			out <= 111;
		end
		else if (inp0 == 0 && inp1 == 63)
		begin
			out <= 112;
		end
		else if (inp0 == 0 && inp1 == 25)
		begin
			out <= 113;
		end
		else if (inp0 == 0 && inp1 == 39)
		begin
			out <= 114;
		end
		else if (inp0 == 0 && inp1 == 29)
		begin
			out <= 115;
		end
		else if (inp0 == 1 && inp1 == 53)
		begin
			out <= 116;
		end
		else if (inp0 == 0 && inp1 == 89)
		begin
			out <= 117;
		end
		else if (inp0 == 0 && inp1 == 36)
		begin
			out <= 118;
		end
		else if (inp0 == 0 && inp1 == 72)
		begin
			out <= 119;
		end
		else if (inp0 == 1 && inp1 == 101)
		begin
			out <= 120;
		end
		else if (inp0 == 0 && inp1 == 47)
		begin
			out <= 121;
		end
		else if (inp0 == 0 && inp1 == 13)
		begin
			out <= 122;
		end
		else if (inp0 == 0 && inp1 == 20)
		begin
			out <= 123;
		end
		else if (inp0 == 0 && inp1 == 31)
		begin
			out <= 124;
		end
		else if (inp0 == 0 && inp1 == 15)
		begin
			out <= 125;
		end
		else if (inp0 == 1 && inp1 == 15)
		begin
			out <= 126;
		end
		else if (inp0 == 1 && inp1 == 31)
		begin
			out <= 127;
		end
		else if (inp0 == 1 && inp1 == 20)
		begin
			out <= 128;
		end
		else if (inp0 == 1 && inp1 == 13)
		begin
			out <= 129;
		end
		else if (inp0 == 1 && inp1 == 47)
		begin
			out <= 130;
		end
		else if (inp0 == 0 && inp1 == 101)
		begin
			out <= 131;
		end
		else if (inp0 == 1 && inp1 == 72)
		begin
			out <= 132;
		end
		else if (inp0 == 1 && inp1 == 36)
		begin
			out <= 133;
		end
		else if (inp0 == 1 && inp1 == 89)
		begin
			out <= 134;
		end
		else if (inp0 == 0 && inp1 == 53)
		begin
			out <= 135;
		end
		else if (inp0 == 1 && inp1 == 29)
		begin
			out <= 136;
		end
		else if (inp0 == 1 && inp1 == 39)
		begin
			out <= 137;
		end
		else if (inp0 == 1 && inp1 == 25)
		begin
			out <= 138;
		end
		else if (inp0 == 1 && inp1 == 63)
		begin
			out <= 139;
		end
		else if (inp0 == 0 && inp1 == 98)
		begin
			out <= 140;
		end
		else if (inp0 == 1 && inp1 == 76)
		begin
			out <= 141;
		end
		else if (inp0 == 0 && inp1 == 117)
		begin
			out <= 142;
		end
		else if (inp0 == 1 && inp1 == 18)
		begin
			out <= 143;
		end
		else if (inp0 == 0 && inp1 == 97)
		begin
			out <= 144;
		end
		else if (inp0 == 1 && inp1 == 88)
		begin
			out <= 145;
		end
		else if (inp0 == 1 && inp1 == 19)
		begin
			out <= 146;
		end
		else if (inp0 == 0 && inp1 == 12)
		begin
			out <= 147;
		end
		else if (inp0 == 1 && inp1 == 52)
		begin
			out <= 148;
		end
		else if (inp0 == 0 && inp1 == 75)
		begin
			out <= 149;
		end
		else if (inp0 == 1 && inp1 == 11)
		begin
			out <= 150;
		end
		else if (inp0 == 1 && inp1 == 105)
		begin
			out <= 151;
		end
		else if (inp0 == 0 && inp1 == 118)
		begin
			out <= 152;
		end
		else if (inp0 == 0 && inp1 == 106)
		begin
			out <= 153;
		end
		else if (inp0 == 0 && inp1 == 69)
		begin
			out <= 154;
		end
		else if (inp0 == 0 && inp1 == 66)
		begin
			out <= 155;
		end
		else if (inp0 == 0 && inp1 == 43)
		begin
			out <= 156;
		end
		else if (inp0 == 1 && inp1 == 45)
		begin
			out <= 157;
		end
		else if (inp0 == 1 && inp1 == 77)
		begin
			out <= 158;
		end
		else if (inp0 == 1 && inp1 == 119)
		begin
			out <= 159;
		end
		else if (inp0 == 1 && inp1 == 55)
		begin
			out <= 160;
		end
		else if (inp0 == 0 && inp1 == 22)
		begin
			out <= 161;
		end
		else if (inp0 == 1 && inp1 == 49)
		begin
			out <= 162;
		end
		else if (inp0 == 1 && inp1 == 41)
		begin
			out <= 163;
		end
		else if (inp0 == 0 && inp1 == 99)
		begin
			out <= 164;
		end
		else if (inp0 == 1 && inp1 == 107)
		begin
			out <= 165;
		end
		else if (inp0 == 1 && inp1 == 79)
		begin
			out <= 166;
		end
		else if (inp0 == 1 && inp1 == 109)
		begin
			out <= 167;
		end
		else if (inp0 == 1 && inp1 == 94)
		begin
			out <= 168;
		end
		else if (inp0 == 0 && inp1 == 114)
		begin
			out <= 169;
		end
		else if (inp0 == 1 && inp1 == 64)
		begin
			out <= 170;
		end
		else if (inp0 == 1 && inp1 == 70)
		begin
			out <= 171;
		end
		else if (inp0 == 1 && inp1 == 92)
		begin
			out <= 172;
		end
		else if (inp0 == 0 && inp1 == 58)
		begin
			out <= 173;
		end
		else if (inp0 == 0 && inp1 == 84)
		begin
			out <= 174;
		end
		else if (inp0 == 0 && inp1 == 8)
		begin
			out <= 175;
		end
		else if (inp0 == 1 && inp1 == 26)
		begin
			out <= 176;
		end
		else if (inp0 == 1 && inp1 == 67)
		begin
			out <= 177;
		end
		else if (inp0 == 1 && inp1 == 34)
		begin
			out <= 178;
		end
		else if (inp0 == 0 && inp1 == 112)
		begin
			out <= 179;
		end
		else if (inp0 == 0 && inp1 == 7)
		begin
			out <= 180;
		end
		else if (inp0 == 0 && inp1 == 113)
		begin
			out <= 181;
		end
		else if (inp0 == 1 && inp1 == 40)
		begin
			out <= 182;
		end
		else if (inp0 == 1 && inp1 == 44)
		begin
			out <= 183;
		end
		else if (inp0 == 1 && inp1 == 104)
		begin
			out <= 184;
		end
		else if (inp0 == 1 && inp1 == 87)
		begin
			out <= 185;
		end
		else if (inp0 == 1 && inp1 == 62)
		begin
			out <= 186;
		end
		else if (inp0 == 1 && inp1 == 35)
		begin
			out <= 187;
		end
		else if (inp0 == 1 && inp1 == 30)
		begin
			out <= 188;
		end
		else if (inp0 == 0 && inp1 == 46)
		begin
			out <= 189;
		end
		else if (inp0 == 0 && inp1 == 28)
		begin
			out <= 190;
		end
		else if (inp0 == 1 && inp1 == 116)
		begin
			out <= 191;
		end
		else if (inp0 == 0 && inp1 == 51)
		begin
			out <= 192;
		end
		else if (inp0 == 1 && inp1 == 68)
		begin
			out <= 193;
		end
		else if (inp0 == 0 && inp1 == 54)
		begin
			out <= 194;
		end
		else if (inp0 == 0 && inp1 == 78)
		begin
			out <= 195;
		end
		else if (inp0 == 0 && inp1 == 91)
		begin
			out <= 196;
		end
		else if (inp0 == 0 && inp1 == 33)
		begin
			out <= 197;
		end
		else if (inp0 == 0 && inp1 == 103)
		begin
			out <= 198;
		end
		else if (inp0 == 1 && inp1 == 27)
		begin
			out <= 199;
		end
		else if (inp0 == 1 && inp1 == 90)
		begin
			out <= 200;
		end
		else if (inp0 == 0 && inp1 == 120)
		begin
			out <= 201;
		end
		else if (inp0 == 1 && inp1 == 121)
		begin
			out <= 202;
		end
		else if (inp0 == 1 && inp1 == 81)
		begin
			out <= 203;
		end
		else if (inp0 == 0 && inp1 == 60)
		begin
			out <= 204;
		end
		else if (inp0 == 0 && inp1 == 9)
		begin
			out <= 205;
		end
		else if (inp0 == 1 && inp1 == 37)
		begin
			out <= 206;
		end
		else if (inp0 == 0 && inp1 == 56)
		begin
			out <= 207;
		end
		else if (inp0 == 0 && inp1 == 122)
		begin
			out <= 208;
		end
		else if (inp0 == 0 && inp1 == 124)
		begin
			out <= 209;
		end
		else if (inp0 == 1 && inp1 == 4)
		begin
			out <= 210;
		end
		else if (inp0 == 0 && inp1 == 85)
		begin
			out <= 211;
		end
		else if (inp0 == 1 && inp1 == 73)
		begin
			out <= 212;
		end
		else if (inp0 == 1 && inp1 == 23)
		begin
			out <= 213;
		end
		else if (inp0 == 0 && inp1 == 82)
		begin
			out <= 214;
		end
		else if (inp0 == 1 && inp1 == 2)
		begin
			out <= 215;
		end
		else if (inp0 == 1 && inp1 == 3)
		begin
			out <= 216;
		end
		else if (inp0 == 0 && inp1 == 59)
		begin
			out <= 217;
		end
		else if (inp0 == 0 && inp1 == 102)
		begin
			out <= 218;
		end
		else if (inp0 == 0 && inp1 == 50)
		begin
			out <= 219;
		end
		else if (inp0 == 1 && inp1 == 61)
		begin
			out <= 220;
		end
		else if (inp0 == 0 && inp1 == 6)
		begin
			out <= 221;
		end
		else if (inp0 == 0 && inp1 == 83)
		begin
			out <= 222;
		end
		else if (inp0 == 1 && inp1 == 93)
		begin
			out <= 223;
		end
		else if (inp0 == 1 && inp1 == 48)
		begin
			out <= 224;
		end
		else if (inp0 == 0 && inp1 == 42)
		begin
			out <= 225;
		end
		else if (inp0 == 1 && inp1 == 10)
		begin
			out <= 226;
		end
		else if (inp0 == 0 && inp1 == 96)
		begin
			out <= 227;
		end
		else if (inp0 == 1 && inp1 == 24)
		begin
			out <= 228;
		end
		else if (inp0 == 1 && inp1 == 71)
		begin
			out <= 229;
		end
		else if (inp0 == 1 && inp1 == 14)
		begin
			out <= 230;
		end
		else if (inp0 == 1 && inp1 == 100)
		begin
			out <= 231;
		end
		else if (inp0 == 0 && inp1 == 38)
		begin
			out <= 232;
		end
		else if (inp0 == 0 && inp1 == 17)
		begin
			out <= 233;
		end
		else if (inp0 == 1 && inp1 == 74)
		begin
			out <= 234;
		end
		else if (inp0 == 1 && inp1 == 65)
		begin
			out <= 235;
		end
		else if (inp0 == 1 && inp1 == 21)
		begin
			out <= 236;
		end
		else if (inp0 == 0 && inp1 == 108)
		begin
			out <= 237;
		end
		else if (inp0 == 1 && inp1 == 57)
		begin
			out <= 238;
		end
		else if (inp0 == 1 && inp1 == 111)
		begin
			out <= 239;
		end
		else if (inp0 == 0 && inp1 == 86)
		begin
			out <= 240;
		end
		else if (inp0 == 0 && inp1 == 115)
		begin
			out <= 241;
		end
		else if (inp0 == 1 && inp1 == 32)
		begin
			out <= 242;
		end
		else if (inp0 == 0 && inp1 == 80)
		begin
			out <= 243;
		end
		else if (inp0 == 1 && inp1 == 123)
		begin
			out <= 244;
		end
		else if (inp0 == 0 && inp1 == 1)
		begin
			out <= 245;
		end
		else if (inp0 == 1 && inp1 == 5)
		begin
			out <= 246;
		end
		else if (inp0 == 1 && inp1 == 95)
		begin
			out <= 247;
		end
		else if (inp0 == 1 && inp1 == 16)
		begin
			out <= 248;
		end
		else if (inp0 == 0 && inp1 == 110)
		begin
			out <= 249;
		end
		else if (inp0 == 1 && inp1 == 0)
		begin
			out <= 250;
		end
		else 
		begin
			out <= 0;
		end
	end
endmodule

module lut_input_251(inp, out0, out1);
	input [7:0] inp;
	output reg [1:0] out0;
	output reg [6:0] out1;
	always @ (inp)
	begin
		case(inp)
		1:
		begin
			out0 <= 0;
			out1 <= 0;
		end
		2:
		begin
			out0 <= 1;
			out1 <= 110;
		end
		3:
		begin
			out0 <= 0;
			out1 <= 16;
		end
		4:
		begin
			out0 <= 0;
			out1 <= 95;
		end
		5:
		begin
			out0 <= 0;
			out1 <= 5;
		end
		6:
		begin
			out0 <= 1;
			out1 <= 1;
		end
		7:
		begin
			out0 <= 0;
			out1 <= 123;
		end
		8:
		begin
			out0 <= 1;
			out1 <= 80;
		end
		9:
		begin
			out0 <= 0;
			out1 <= 32;
		end
		10:
		begin
			out0 <= 1;
			out1 <= 115;
		end
		11:
		begin
			out0 <= 1;
			out1 <= 86;
		end
		12:
		begin
			out0 <= 0;
			out1 <= 111;
		end
		13:
		begin
			out0 <= 0;
			out1 <= 57;
		end
		14:
		begin
			out0 <= 1;
			out1 <= 108;
		end
		15:
		begin
			out0 <= 0;
			out1 <= 21;
		end
		16:
		begin
			out0 <= 0;
			out1 <= 65;
		end
		17:
		begin
			out0 <= 0;
			out1 <= 74;
		end
		18:
		begin
			out0 <= 1;
			out1 <= 17;
		end
		19:
		begin
			out0 <= 1;
			out1 <= 38;
		end
		20:
		begin
			out0 <= 0;
			out1 <= 100;
		end
		21:
		begin
			out0 <= 0;
			out1 <= 14;
		end
		22:
		begin
			out0 <= 0;
			out1 <= 71;
		end
		23:
		begin
			out0 <= 0;
			out1 <= 24;
		end
		24:
		begin
			out0 <= 1;
			out1 <= 96;
		end
		25:
		begin
			out0 <= 0;
			out1 <= 10;
		end
		26:
		begin
			out0 <= 1;
			out1 <= 42;
		end
		27:
		begin
			out0 <= 0;
			out1 <= 48;
		end
		28:
		begin
			out0 <= 0;
			out1 <= 93;
		end
		29:
		begin
			out0 <= 1;
			out1 <= 83;
		end
		30:
		begin
			out0 <= 1;
			out1 <= 6;
		end
		31:
		begin
			out0 <= 0;
			out1 <= 61;
		end
		32:
		begin
			out0 <= 1;
			out1 <= 50;
		end
		33:
		begin
			out0 <= 1;
			out1 <= 102;
		end
		34:
		begin
			out0 <= 1;
			out1 <= 59;
		end
		35:
		begin
			out0 <= 0;
			out1 <= 3;
		end
		36:
		begin
			out0 <= 0;
			out1 <= 2;
		end
		37:
		begin
			out0 <= 1;
			out1 <= 82;
		end
		38:
		begin
			out0 <= 0;
			out1 <= 23;
		end
		39:
		begin
			out0 <= 0;
			out1 <= 73;
		end
		40:
		begin
			out0 <= 1;
			out1 <= 85;
		end
		41:
		begin
			out0 <= 0;
			out1 <= 4;
		end
		42:
		begin
			out0 <= 1;
			out1 <= 124;
		end
		43:
		begin
			out0 <= 1;
			out1 <= 122;
		end
		44:
		begin
			out0 <= 1;
			out1 <= 56;
		end
		45:
		begin
			out0 <= 0;
			out1 <= 37;
		end
		46:
		begin
			out0 <= 1;
			out1 <= 9;
		end
		47:
		begin
			out0 <= 1;
			out1 <= 60;
		end
		48:
		begin
			out0 <= 0;
			out1 <= 81;
		end
		49:
		begin
			out0 <= 0;
			out1 <= 121;
		end
		50:
		begin
			out0 <= 1;
			out1 <= 120;
		end
		51:
		begin
			out0 <= 0;
			out1 <= 90;
		end
		52:
		begin
			out0 <= 0;
			out1 <= 27;
		end
		53:
		begin
			out0 <= 1;
			out1 <= 103;
		end
		54:
		begin
			out0 <= 1;
			out1 <= 33;
		end
		55:
		begin
			out0 <= 1;
			out1 <= 91;
		end
		56:
		begin
			out0 <= 1;
			out1 <= 78;
		end
		57:
		begin
			out0 <= 1;
			out1 <= 54;
		end
		58:
		begin
			out0 <= 0;
			out1 <= 68;
		end
		59:
		begin
			out0 <= 1;
			out1 <= 51;
		end
		60:
		begin
			out0 <= 0;
			out1 <= 116;
		end
		61:
		begin
			out0 <= 1;
			out1 <= 28;
		end
		62:
		begin
			out0 <= 1;
			out1 <= 46;
		end
		63:
		begin
			out0 <= 0;
			out1 <= 30;
		end
		64:
		begin
			out0 <= 0;
			out1 <= 35;
		end
		65:
		begin
			out0 <= 0;
			out1 <= 62;
		end
		66:
		begin
			out0 <= 0;
			out1 <= 87;
		end
		67:
		begin
			out0 <= 0;
			out1 <= 104;
		end
		68:
		begin
			out0 <= 0;
			out1 <= 44;
		end
		69:
		begin
			out0 <= 0;
			out1 <= 40;
		end
		70:
		begin
			out0 <= 1;
			out1 <= 113;
		end
		71:
		begin
			out0 <= 1;
			out1 <= 7;
		end
		72:
		begin
			out0 <= 1;
			out1 <= 112;
		end
		73:
		begin
			out0 <= 0;
			out1 <= 34;
		end
		74:
		begin
			out0 <= 0;
			out1 <= 67;
		end
		75:
		begin
			out0 <= 0;
			out1 <= 26;
		end
		76:
		begin
			out0 <= 1;
			out1 <= 8;
		end
		77:
		begin
			out0 <= 1;
			out1 <= 84;
		end
		78:
		begin
			out0 <= 1;
			out1 <= 58;
		end
		79:
		begin
			out0 <= 0;
			out1 <= 92;
		end
		80:
		begin
			out0 <= 0;
			out1 <= 70;
		end
		81:
		begin
			out0 <= 0;
			out1 <= 64;
		end
		82:
		begin
			out0 <= 1;
			out1 <= 114;
		end
		83:
		begin
			out0 <= 0;
			out1 <= 94;
		end
		84:
		begin
			out0 <= 0;
			out1 <= 109;
		end
		85:
		begin
			out0 <= 0;
			out1 <= 79;
		end
		86:
		begin
			out0 <= 0;
			out1 <= 107;
		end
		87:
		begin
			out0 <= 1;
			out1 <= 99;
		end
		88:
		begin
			out0 <= 0;
			out1 <= 41;
		end
		89:
		begin
			out0 <= 0;
			out1 <= 49;
		end
		90:
		begin
			out0 <= 1;
			out1 <= 22;
		end
		91:
		begin
			out0 <= 0;
			out1 <= 55;
		end
		92:
		begin
			out0 <= 0;
			out1 <= 119;
		end
		93:
		begin
			out0 <= 0;
			out1 <= 77;
		end
		94:
		begin
			out0 <= 0;
			out1 <= 45;
		end
		95:
		begin
			out0 <= 1;
			out1 <= 43;
		end
		96:
		begin
			out0 <= 1;
			out1 <= 66;
		end
		97:
		begin
			out0 <= 1;
			out1 <= 69;
		end
		98:
		begin
			out0 <= 1;
			out1 <= 106;
		end
		99:
		begin
			out0 <= 1;
			out1 <= 118;
		end
		100:
		begin
			out0 <= 0;
			out1 <= 105;
		end
		101:
		begin
			out0 <= 0;
			out1 <= 11;
		end
		102:
		begin
			out0 <= 1;
			out1 <= 75;
		end
		103:
		begin
			out0 <= 0;
			out1 <= 52;
		end
		104:
		begin
			out0 <= 1;
			out1 <= 12;
		end
		105:
		begin
			out0 <= 0;
			out1 <= 19;
		end
		106:
		begin
			out0 <= 0;
			out1 <= 88;
		end
		107:
		begin
			out0 <= 1;
			out1 <= 97;
		end
		108:
		begin
			out0 <= 0;
			out1 <= 18;
		end
		109:
		begin
			out0 <= 1;
			out1 <= 117;
		end
		110:
		begin
			out0 <= 0;
			out1 <= 76;
		end
		111:
		begin
			out0 <= 1;
			out1 <= 98;
		end
		112:
		begin
			out0 <= 0;
			out1 <= 63;
		end
		113:
		begin
			out0 <= 0;
			out1 <= 25;
		end
		114:
		begin
			out0 <= 0;
			out1 <= 39;
		end
		115:
		begin
			out0 <= 0;
			out1 <= 29;
		end
		116:
		begin
			out0 <= 1;
			out1 <= 53;
		end
		117:
		begin
			out0 <= 0;
			out1 <= 89;
		end
		118:
		begin
			out0 <= 0;
			out1 <= 36;
		end
		119:
		begin
			out0 <= 0;
			out1 <= 72;
		end
		120:
		begin
			out0 <= 1;
			out1 <= 101;
		end
		121:
		begin
			out0 <= 0;
			out1 <= 47;
		end
		122:
		begin
			out0 <= 0;
			out1 <= 13;
		end
		123:
		begin
			out0 <= 0;
			out1 <= 20;
		end
		124:
		begin
			out0 <= 0;
			out1 <= 31;
		end
		125:
		begin
			out0 <= 0;
			out1 <= 15;
		end
		126:
		begin
			out0 <= 1;
			out1 <= 15;
		end
		127:
		begin
			out0 <= 1;
			out1 <= 31;
		end
		128:
		begin
			out0 <= 1;
			out1 <= 20;
		end
		129:
		begin
			out0 <= 1;
			out1 <= 13;
		end
		130:
		begin
			out0 <= 1;
			out1 <= 47;
		end
		131:
		begin
			out0 <= 0;
			out1 <= 101;
		end
		132:
		begin
			out0 <= 1;
			out1 <= 72;
		end
		133:
		begin
			out0 <= 1;
			out1 <= 36;
		end
		134:
		begin
			out0 <= 1;
			out1 <= 89;
		end
		135:
		begin
			out0 <= 0;
			out1 <= 53;
		end
		136:
		begin
			out0 <= 1;
			out1 <= 29;
		end
		137:
		begin
			out0 <= 1;
			out1 <= 39;
		end
		138:
		begin
			out0 <= 1;
			out1 <= 25;
		end
		139:
		begin
			out0 <= 1;
			out1 <= 63;
		end
		140:
		begin
			out0 <= 0;
			out1 <= 98;
		end
		141:
		begin
			out0 <= 1;
			out1 <= 76;
		end
		142:
		begin
			out0 <= 0;
			out1 <= 117;
		end
		143:
		begin
			out0 <= 1;
			out1 <= 18;
		end
		144:
		begin
			out0 <= 0;
			out1 <= 97;
		end
		145:
		begin
			out0 <= 1;
			out1 <= 88;
		end
		146:
		begin
			out0 <= 1;
			out1 <= 19;
		end
		147:
		begin
			out0 <= 0;
			out1 <= 12;
		end
		148:
		begin
			out0 <= 1;
			out1 <= 52;
		end
		149:
		begin
			out0 <= 0;
			out1 <= 75;
		end
		150:
		begin
			out0 <= 1;
			out1 <= 11;
		end
		151:
		begin
			out0 <= 1;
			out1 <= 105;
		end
		152:
		begin
			out0 <= 0;
			out1 <= 118;
		end
		153:
		begin
			out0 <= 0;
			out1 <= 106;
		end
		154:
		begin
			out0 <= 0;
			out1 <= 69;
		end
		155:
		begin
			out0 <= 0;
			out1 <= 66;
		end
		156:
		begin
			out0 <= 0;
			out1 <= 43;
		end
		157:
		begin
			out0 <= 1;
			out1 <= 45;
		end
		158:
		begin
			out0 <= 1;
			out1 <= 77;
		end
		159:
		begin
			out0 <= 1;
			out1 <= 119;
		end
		160:
		begin
			out0 <= 1;
			out1 <= 55;
		end
		161:
		begin
			out0 <= 0;
			out1 <= 22;
		end
		162:
		begin
			out0 <= 1;
			out1 <= 49;
		end
		163:
		begin
			out0 <= 1;
			out1 <= 41;
		end
		164:
		begin
			out0 <= 0;
			out1 <= 99;
		end
		165:
		begin
			out0 <= 1;
			out1 <= 107;
		end
		166:
		begin
			out0 <= 1;
			out1 <= 79;
		end
		167:
		begin
			out0 <= 1;
			out1 <= 109;
		end
		168:
		begin
			out0 <= 1;
			out1 <= 94;
		end
		169:
		begin
			out0 <= 0;
			out1 <= 114;
		end
		170:
		begin
			out0 <= 1;
			out1 <= 64;
		end
		171:
		begin
			out0 <= 1;
			out1 <= 70;
		end
		172:
		begin
			out0 <= 1;
			out1 <= 92;
		end
		173:
		begin
			out0 <= 0;
			out1 <= 58;
		end
		174:
		begin
			out0 <= 0;
			out1 <= 84;
		end
		175:
		begin
			out0 <= 0;
			out1 <= 8;
		end
		176:
		begin
			out0 <= 1;
			out1 <= 26;
		end
		177:
		begin
			out0 <= 1;
			out1 <= 67;
		end
		178:
		begin
			out0 <= 1;
			out1 <= 34;
		end
		179:
		begin
			out0 <= 0;
			out1 <= 112;
		end
		180:
		begin
			out0 <= 0;
			out1 <= 7;
		end
		181:
		begin
			out0 <= 0;
			out1 <= 113;
		end
		182:
		begin
			out0 <= 1;
			out1 <= 40;
		end
		183:
		begin
			out0 <= 1;
			out1 <= 44;
		end
		184:
		begin
			out0 <= 1;
			out1 <= 104;
		end
		185:
		begin
			out0 <= 1;
			out1 <= 87;
		end
		186:
		begin
			out0 <= 1;
			out1 <= 62;
		end
		187:
		begin
			out0 <= 1;
			out1 <= 35;
		end
		188:
		begin
			out0 <= 1;
			out1 <= 30;
		end
		189:
		begin
			out0 <= 0;
			out1 <= 46;
		end
		190:
		begin
			out0 <= 0;
			out1 <= 28;
		end
		191:
		begin
			out0 <= 1;
			out1 <= 116;
		end
		192:
		begin
			out0 <= 0;
			out1 <= 51;
		end
		193:
		begin
			out0 <= 1;
			out1 <= 68;
		end
		194:
		begin
			out0 <= 0;
			out1 <= 54;
		end
		195:
		begin
			out0 <= 0;
			out1 <= 78;
		end
		196:
		begin
			out0 <= 0;
			out1 <= 91;
		end
		197:
		begin
			out0 <= 0;
			out1 <= 33;
		end
		198:
		begin
			out0 <= 0;
			out1 <= 103;
		end
		199:
		begin
			out0 <= 1;
			out1 <= 27;
		end
		200:
		begin
			out0 <= 1;
			out1 <= 90;
		end
		201:
		begin
			out0 <= 0;
			out1 <= 120;
		end
		202:
		begin
			out0 <= 1;
			out1 <= 121;
		end
		203:
		begin
			out0 <= 1;
			out1 <= 81;
		end
		204:
		begin
			out0 <= 0;
			out1 <= 60;
		end
		205:
		begin
			out0 <= 0;
			out1 <= 9;
		end
		206:
		begin
			out0 <= 1;
			out1 <= 37;
		end
		207:
		begin
			out0 <= 0;
			out1 <= 56;
		end
		208:
		begin
			out0 <= 0;
			out1 <= 122;
		end
		209:
		begin
			out0 <= 0;
			out1 <= 124;
		end
		210:
		begin
			out0 <= 1;
			out1 <= 4;
		end
		211:
		begin
			out0 <= 0;
			out1 <= 85;
		end
		212:
		begin
			out0 <= 1;
			out1 <= 73;
		end
		213:
		begin
			out0 <= 1;
			out1 <= 23;
		end
		214:
		begin
			out0 <= 0;
			out1 <= 82;
		end
		215:
		begin
			out0 <= 1;
			out1 <= 2;
		end
		216:
		begin
			out0 <= 1;
			out1 <= 3;
		end
		217:
		begin
			out0 <= 0;
			out1 <= 59;
		end
		218:
		begin
			out0 <= 0;
			out1 <= 102;
		end
		219:
		begin
			out0 <= 0;
			out1 <= 50;
		end
		220:
		begin
			out0 <= 1;
			out1 <= 61;
		end
		221:
		begin
			out0 <= 0;
			out1 <= 6;
		end
		222:
		begin
			out0 <= 0;
			out1 <= 83;
		end
		223:
		begin
			out0 <= 1;
			out1 <= 93;
		end
		224:
		begin
			out0 <= 1;
			out1 <= 48;
		end
		225:
		begin
			out0 <= 0;
			out1 <= 42;
		end
		226:
		begin
			out0 <= 1;
			out1 <= 10;
		end
		227:
		begin
			out0 <= 0;
			out1 <= 96;
		end
		228:
		begin
			out0 <= 1;
			out1 <= 24;
		end
		229:
		begin
			out0 <= 1;
			out1 <= 71;
		end
		230:
		begin
			out0 <= 1;
			out1 <= 14;
		end
		231:
		begin
			out0 <= 1;
			out1 <= 100;
		end
		232:
		begin
			out0 <= 0;
			out1 <= 38;
		end
		233:
		begin
			out0 <= 0;
			out1 <= 17;
		end
		234:
		begin
			out0 <= 1;
			out1 <= 74;
		end
		235:
		begin
			out0 <= 1;
			out1 <= 65;
		end
		236:
		begin
			out0 <= 1;
			out1 <= 21;
		end
		237:
		begin
			out0 <= 0;
			out1 <= 108;
		end
		238:
		begin
			out0 <= 1;
			out1 <= 57;
		end
		239:
		begin
			out0 <= 1;
			out1 <= 111;
		end
		240:
		begin
			out0 <= 0;
			out1 <= 86;
		end
		241:
		begin
			out0 <= 0;
			out1 <= 115;
		end
		242:
		begin
			out0 <= 1;
			out1 <= 32;
		end
		243:
		begin
			out0 <= 0;
			out1 <= 80;
		end
		244:
		begin
			out0 <= 1;
			out1 <= 123;
		end
		245:
		begin
			out0 <= 0;
			out1 <= 1;
		end
		246:
		begin
			out0 <= 1;
			out1 <= 5;
		end
		247:
		begin
			out0 <= 1;
			out1 <= 95;
		end
		248:
		begin
			out0 <= 1;
			out1 <= 16;
		end
		249:
		begin
			out0 <= 0;
			out1 <= 110;
		end
		250:
		begin
			out0 <= 1;
			out1 <= 0;
		end
		default:
		begin
			out0 <= 0;
			out1 <= 0;
		end
		endcase
	end
endmodule