module multiplication_mod_509(inp1, inp2, out);
	input [8:0] inp1;
	input [8:0] inp2;
	output reg [8:0] out;
	wire [8:0] out_pre;
	wire [2:0] w_1_0;
	wire [2:0] w_2_0;
	wire [2:0] wout_0;
	wire [6:0] w_1_1;
	wire [6:0] w_2_1;
	wire [6:0] wout_1;
	lut_input_509 lut1(inp1, w_1_0, w_1_1);
	lut_input_509 lut2(inp2, w_2_0, w_2_1);
	sum_modulo_4 sm0(w_1_0, w_2_0, wout_0);
	sum_modulo_127 sm1(w_1_1, w_2_1, wout_1);
	lut_output_509 lut3(wout_0, wout_1, out_pre);
	always @ (*)
	begin
		if (inp1 == 0 || inp2 == 0)
		begin
			out = 0;
		end
		else
		begin
			out = out_pre;
		end
	end
endmodule

module sum_modulo_4(inp1, inp2, out);
	input [2:0] inp1;
	input [2:0] inp2;
	output reg [2:0] out;
	wire [3:0] int;
	assign int = inp1 + inp2;
	always @ (*)
	begin
		if (int < 4)
		begin
			out = int;
		end
		else
		begin
			out = int - 4;
		end
	end
endmodule

module sum_modulo_127(inp1, inp2, out);
	input [6:0] inp1;
	input [6:0] inp2;
	output reg [6:0] out;
	wire [7:0] int;
	assign int = inp1 + inp2;
	always @ (*)
	begin
		if (int < 127)
		begin
			out = int;
		end
		else
		begin
			out = int - 127;
		end
	end
endmodule

module lut_output_509(inp0, inp1, out);
	output reg [8:0] out;
	input [2:0] inp0;
	input [6:0] inp1;
	always @ (*)
	begin
		if (inp0 == 0 && inp1 == 0)
		begin
			out <= 1;
		end
		else if (inp0 == 1 && inp1 == 1)
		begin
			out <= 2;
		end
		else if (inp0 == 1 && inp1 == 9)
		begin
			out <= 3;
		end
		else if (inp0 == 2 && inp1 == 2)
		begin
			out <= 4;
		end
		else if (inp0 == 2 && inp1 == 90)
		begin
			out <= 5;
		end
		else if (inp0 == 2 && inp1 == 10)
		begin
			out <= 6;
		end
		else if (inp0 == 3 && inp1 == 69)
		begin
			out <= 7;
		end
		else if (inp0 == 3 && inp1 == 3)
		begin
			out <= 8;
		end
		else if (inp0 == 2 && inp1 == 18)
		begin
			out <= 9;
		end
		else if (inp0 == 3 && inp1 == 91)
		begin
			out <= 10;
		end
		else if (inp0 == 2 && inp1 == 89)
		begin
			out <= 11;
		end
		else if (inp0 == 3 && inp1 == 11)
		begin
			out <= 12;
		end
		else if (inp0 == 1 && inp1 == 123)
		begin
			out <= 13;
		end
		else if (inp0 == 0 && inp1 == 70)
		begin
			out <= 14;
		end
		else if (inp0 == 3 && inp1 == 99)
		begin
			out <= 15;
		end
		else if (inp0 == 0 && inp1 == 4)
		begin
			out <= 16;
		end
		else if (inp0 == 0 && inp1 == 27)
		begin
			out <= 17;
		end
		else if (inp0 == 3 && inp1 == 19)
		begin
			out <= 18;
		end
		else if (inp0 == 3 && inp1 == 102)
		begin
			out <= 19;
		end
		else if (inp0 == 0 && inp1 == 92)
		begin
			out <= 20;
		end
		else if (inp0 == 0 && inp1 == 78)
		begin
			out <= 21;
		end
		else if (inp0 == 3 && inp1 == 90)
		begin
			out <= 22;
		end
		else if (inp0 == 0 && inp1 == 46)
		begin
			out <= 23;
		end
		else if (inp0 == 0 && inp1 == 12)
		begin
			out <= 24;
		end
		else if (inp0 == 0 && inp1 == 53)
		begin
			out <= 25;
		end
		else if (inp0 == 2 && inp1 == 124)
		begin
			out <= 26;
		end
		else if (inp0 == 3 && inp1 == 27)
		begin
			out <= 27;
		end
		else if (inp0 == 1 && inp1 == 71)
		begin
			out <= 28;
		end
		else if (inp0 == 2 && inp1 == 104)
		begin
			out <= 29;
		end
		else if (inp0 == 0 && inp1 == 100)
		begin
			out <= 30;
		end
		else if (inp0 == 3 && inp1 == 119)
		begin
			out <= 31;
		end
		else if (inp0 == 1 && inp1 == 5)
		begin
			out <= 32;
		end
		else if (inp0 == 3 && inp1 == 98)
		begin
			out <= 33;
		end
		else if (inp0 == 1 && inp1 == 28)
		begin
			out <= 34;
		end
		else if (inp0 == 1 && inp1 == 32)
		begin
			out <= 35;
		end
		else if (inp0 == 0 && inp1 == 20)
		begin
			out <= 36;
		end
		else if (inp0 == 2 && inp1 == 75)
		begin
			out <= 37;
		end
		else if (inp0 == 0 && inp1 == 103)
		begin
			out <= 38;
		end
		else if (inp0 == 2 && inp1 == 5)
		begin
			out <= 39;
		end
		else if (inp0 == 1 && inp1 == 93)
		begin
			out <= 40;
		end
		else if (inp0 == 3 && inp1 == 16)
		begin
			out <= 41;
		end
		else if (inp0 == 1 && inp1 == 79)
		begin
			out <= 42;
		end
		else if (inp0 == 0 && inp1 == 58)
		begin
			out <= 43;
		end
		else if (inp0 == 0 && inp1 == 91)
		begin
			out <= 44;
		end
		else if (inp0 == 0 && inp1 == 108)
		begin
			out <= 45;
		end
		else if (inp0 == 1 && inp1 == 47)
		begin
			out <= 46;
		end
		else if (inp0 == 1 && inp1 == 41)
		begin
			out <= 47;
		end
		else if (inp0 == 1 && inp1 == 13)
		begin
			out <= 48;
		end
		else if (inp0 == 2 && inp1 == 11)
		begin
			out <= 49;
		end
		else if (inp0 == 1 && inp1 == 54)
		begin
			out <= 50;
		end
		else if (inp0 == 1 && inp1 == 36)
		begin
			out <= 51;
		end
		else if (inp0 == 3 && inp1 == 125)
		begin
			out <= 52;
		end
		else if (inp0 == 1 && inp1 == 114)
		begin
			out <= 53;
		end
		else if (inp0 == 0 && inp1 == 28)
		begin
			out <= 54;
		end
		else if (inp0 == 0 && inp1 == 52)
		begin
			out <= 55;
		end
		else if (inp0 == 2 && inp1 == 72)
		begin
			out <= 56;
		end
		else if (inp0 == 0 && inp1 == 111)
		begin
			out <= 57;
		end
		else if (inp0 == 3 && inp1 == 105)
		begin
			out <= 58;
		end
		else if (inp0 == 1 && inp1 == 72)
		begin
			out <= 59;
		end
		else if (inp0 == 1 && inp1 == 101)
		begin
			out <= 60;
		end
		else if (inp0 == 3 && inp1 == 75)
		begin
			out <= 61;
		end
		else if (inp0 == 0 && inp1 == 120)
		begin
			out <= 62;
		end
		else if (inp0 == 1 && inp1 == 87)
		begin
			out <= 63;
		end
		else if (inp0 == 2 && inp1 == 6)
		begin
			out <= 64;
		end
		else if (inp0 == 3 && inp1 == 86)
		begin
			out <= 65;
		end
		else if (inp0 == 0 && inp1 == 99)
		begin
			out <= 66;
		end
		else if (inp0 == 0 && inp1 == 24)
		begin
			out <= 67;
		end
		else if (inp0 == 2 && inp1 == 29)
		begin
			out <= 68;
		end
		else if (inp0 == 1 && inp1 == 55)
		begin
			out <= 69;
		end
		else if (inp0 == 2 && inp1 == 33)
		begin
			out <= 70;
		end
		else if (inp0 == 2 && inp1 == 69)
		begin
			out <= 71;
		end
		else if (inp0 == 1 && inp1 == 21)
		begin
			out <= 72;
		end
		else if (inp0 == 2 && inp1 == 59)
		begin
			out <= 73;
		end
		else if (inp0 == 3 && inp1 == 76)
		begin
			out <= 74;
		end
		else if (inp0 == 1 && inp1 == 62)
		begin
			out <= 75;
		end
		else if (inp0 == 1 && inp1 == 104)
		begin
			out <= 76;
		end
		else if (inp0 == 1 && inp1 == 31)
		begin
			out <= 77;
		end
		else if (inp0 == 3 && inp1 == 6)
		begin
			out <= 78;
		end
		else if (inp0 == 1 && inp1 == 22)
		begin
			out <= 79;
		end
		else if (inp0 == 2 && inp1 == 94)
		begin
			out <= 80;
		end
		else if (inp0 == 0 && inp1 == 36)
		begin
			out <= 81;
		end
		else if (inp0 == 0 && inp1 == 17)
		begin
			out <= 82;
		end
		else if (inp0 == 2 && inp1 == 79)
		begin
			out <= 83;
		end
		else if (inp0 == 2 && inp1 == 80)
		begin
			out <= 84;
		end
		else if (inp0 == 2 && inp1 == 117)
		begin
			out <= 85;
		end
		else if (inp0 == 1 && inp1 == 59)
		begin
			out <= 86;
		end
		else if (inp0 == 3 && inp1 == 113)
		begin
			out <= 87;
		end
		else if (inp0 == 1 && inp1 == 92)
		begin
			out <= 88;
		end
		else if (inp0 == 2 && inp1 == 43)
		begin
			out <= 89;
		end
		else if (inp0 == 1 && inp1 == 109)
		begin
			out <= 90;
		end
		else if (inp0 == 0 && inp1 == 65)
		begin
			out <= 91;
		end
		else if (inp0 == 2 && inp1 == 48)
		begin
			out <= 92;
		end
		else if (inp0 == 0 && inp1 == 1)
		begin
			out <= 93;
		end
		else if (inp0 == 2 && inp1 == 42)
		begin
			out <= 94;
		end
		else if (inp0 == 1 && inp1 == 65)
		begin
			out <= 95;
		end
		else if (inp0 == 2 && inp1 == 14)
		begin
			out <= 96;
		end
		else if (inp0 == 0 && inp1 == 49)
		begin
			out <= 97;
		end
		else if (inp0 == 3 && inp1 == 12)
		begin
			out <= 98;
		end
		else if (inp0 == 0 && inp1 == 107)
		begin
			out <= 99;
		end
		else if (inp0 == 2 && inp1 == 55)
		begin
			out <= 100;
		end
		else if (inp0 == 2 && inp1 == 39)
		begin
			out <= 101;
		end
		else if (inp0 == 2 && inp1 == 37)
		begin
			out <= 102;
		end
		else if (inp0 == 0 && inp1 == 47)
		begin
			out <= 103;
		end
		else if (inp0 == 0 && inp1 == 126)
		begin
			out <= 104;
		end
		else if (inp0 == 2 && inp1 == 41)
		begin
			out <= 105;
		end
		else if (inp0 == 2 && inp1 == 115)
		begin
			out <= 106;
		end
		else if (inp0 == 0 && inp1 == 34)
		begin
			out <= 107;
		end
		else if (inp0 == 1 && inp1 == 29)
		begin
			out <= 108;
		end
		else if (inp0 == 2 && inp1 == 57)
		begin
			out <= 109;
		end
		else if (inp0 == 1 && inp1 == 53)
		begin
			out <= 110;
		end
		else if (inp0 == 3 && inp1 == 84)
		begin
			out <= 111;
		end
		else if (inp0 == 3 && inp1 == 73)
		begin
			out <= 112;
		end
		else if (inp0 == 0 && inp1 == 109)
		begin
			out <= 113;
		end
		else if (inp0 == 1 && inp1 == 112)
		begin
			out <= 114;
		end
		else if (inp0 == 2 && inp1 == 9)
		begin
			out <= 115;
		end
		else if (inp0 == 0 && inp1 == 106)
		begin
			out <= 116;
		end
		else if (inp0 == 3 && inp1 == 14)
		begin
			out <= 117;
		end
		else if (inp0 == 2 && inp1 == 73)
		begin
			out <= 118;
		end
		else if (inp0 == 3 && inp1 == 96)
		begin
			out <= 119;
		end
		else if (inp0 == 2 && inp1 == 102)
		begin
			out <= 120;
		end
		else if (inp0 == 0 && inp1 == 51)
		begin
			out <= 121;
		end
		else if (inp0 == 0 && inp1 == 76)
		begin
			out <= 122;
		end
		else if (inp0 == 0 && inp1 == 25)
		begin
			out <= 123;
		end
		else if (inp0 == 1 && inp1 == 121)
		begin
			out <= 124;
		end
		else if (inp0 == 2 && inp1 == 16)
		begin
			out <= 125;
		end
		else if (inp0 == 2 && inp1 == 88)
		begin
			out <= 126;
		end
		else if (inp0 == 0 && inp1 == 125)
		begin
			out <= 127;
		end
		else if (inp0 == 3 && inp1 == 7)
		begin
			out <= 128;
		end
		else if (inp0 == 1 && inp1 == 67)
		begin
			out <= 129;
		end
		else if (inp0 == 0 && inp1 == 87)
		begin
			out <= 130;
		end
		else if (inp0 == 1 && inp1 == 97)
		begin
			out <= 131;
		end
		else if (inp0 == 1 && inp1 == 100)
		begin
			out <= 132;
		end
		else if (inp0 == 2 && inp1 == 44)
		begin
			out <= 133;
		end
		else if (inp0 == 1 && inp1 == 25)
		begin
			out <= 134;
		end
		else if (inp0 == 1 && inp1 == 117)
		begin
			out <= 135;
		end
		else if (inp0 == 3 && inp1 == 30)
		begin
			out <= 136;
		end
		else if (inp0 == 0 && inp1 == 3)
		begin
			out <= 137;
		end
		else if (inp0 == 2 && inp1 == 56)
		begin
			out <= 138;
		end
		else if (inp0 == 3 && inp1 == 39)
		begin
			out <= 139;
		end
		else if (inp0 == 3 && inp1 == 34)
		begin
			out <= 140;
		end
		else if (inp0 == 2 && inp1 == 50)
		begin
			out <= 141;
		end
		else if (inp0 == 3 && inp1 == 70)
		begin
			out <= 142;
		end
		else if (inp0 == 3 && inp1 == 85)
		begin
			out <= 143;
		end
		else if (inp0 == 2 && inp1 == 22)
		begin
			out <= 144;
		end
		else if (inp0 == 0 && inp1 == 67)
		begin
			out <= 145;
		end
		else if (inp0 == 3 && inp1 == 60)
		begin
			out <= 146;
		end
		else if (inp0 == 3 && inp1 == 20)
		begin
			out <= 147;
		end
		else if (inp0 == 0 && inp1 == 77)
		begin
			out <= 148;
		end
		else if (inp0 == 1 && inp1 == 111)
		begin
			out <= 149;
		end
		else if (inp0 == 2 && inp1 == 63)
		begin
			out <= 150;
		end
		else if (inp0 == 3 && inp1 == 63)
		begin
			out <= 151;
		end
		else if (inp0 == 2 && inp1 == 105)
		begin
			out <= 152;
		end
		else if (inp0 == 2 && inp1 == 45)
		begin
			out <= 153;
		end
		else if (inp0 == 2 && inp1 == 32)
		begin
			out <= 154;
		end
		else if (inp0 == 1 && inp1 == 82)
		begin
			out <= 155;
		end
		else if (inp0 == 0 && inp1 == 7)
		begin
			out <= 156;
		end
		else if (inp0 == 1 && inp1 == 94)
		begin
			out <= 157;
		end
		else if (inp0 == 2 && inp1 == 23)
		begin
			out <= 158;
		end
		else if (inp0 == 2 && inp1 == 123)
		begin
			out <= 159;
		end
		else if (inp0 == 3 && inp1 == 95)
		begin
			out <= 160;
		end
		else if (inp0 == 3 && inp1 == 115)
		begin
			out <= 161;
		end
		else if (inp0 == 1 && inp1 == 37)
		begin
			out <= 162;
		end
		else if (inp0 == 1 && inp1 == 83)
		begin
			out <= 163;
		end
		else if (inp0 == 1 && inp1 == 18)
		begin
			out <= 164;
		end
		else if (inp0 == 1 && inp1 == 61)
		begin
			out <= 165;
		end
		else if (inp0 == 3 && inp1 == 80)
		begin
			out <= 166;
		end
		else if (inp0 == 0 && inp1 == 121)
		begin
			out <= 167;
		end
		else if (inp0 == 3 && inp1 == 81)
		begin
			out <= 168;
		end
		else if (inp0 == 2 && inp1 == 119)
		begin
			out <= 169;
		end
		else if (inp0 == 3 && inp1 == 118)
		begin
			out <= 170;
		end
		else if (inp0 == 1 && inp1 == 120)
		begin
			out <= 171;
		end
		else if (inp0 == 2 && inp1 == 60)
		begin
			out <= 172;
		end
		else if (inp0 == 2 && inp1 == 82)
		begin
			out <= 173;
		end
		else if (inp0 == 0 && inp1 == 114)
		begin
			out <= 174;
		end
		else if (inp0 == 3 && inp1 == 122)
		begin
			out <= 175;
		end
		else if (inp0 == 2 && inp1 == 93)
		begin
			out <= 176;
		end
		else if (inp0 == 2 && inp1 == 81)
		begin
			out <= 177;
		end
		else if (inp0 == 3 && inp1 == 44)
		begin
			out <= 178;
		end
		else if (inp0 == 0 && inp1 == 62)
		begin
			out <= 179;
		end
		else if (inp0 == 2 && inp1 == 110)
		begin
			out <= 180;
		end
		else if (inp0 == 0 && inp1 == 19)
		begin
			out <= 181;
		end
		else if (inp0 == 1 && inp1 == 66)
		begin
			out <= 182;
		end
		else if (inp0 == 0 && inp1 == 84)
		begin
			out <= 183;
		end
		else if (inp0 == 3 && inp1 == 49)
		begin
			out <= 184;
		end
		else if (inp0 == 0 && inp1 == 38)
		begin
			out <= 185;
		end
		else if (inp0 == 1 && inp1 == 2)
		begin
			out <= 186;
		end
		else if (inp0 == 2 && inp1 == 116)
		begin
			out <= 187;
		end
		else if (inp0 == 3 && inp1 == 43)
		begin
			out <= 188;
		end
		else if (inp0 == 2 && inp1 == 96)
		begin
			out <= 189;
		end
		else if (inp0 == 2 && inp1 == 66)
		begin
			out <= 190;
		end
		else if (inp0 == 1 && inp1 == 124)
		begin
			out <= 191;
		end
		else if (inp0 == 3 && inp1 == 15)
		begin
			out <= 192;
		end
		else if (inp0 == 1 && inp1 == 24)
		begin
			out <= 193;
		end
		else if (inp0 == 1 && inp1 == 50)
		begin
			out <= 194;
		end
		else if (inp0 == 0 && inp1 == 95)
		begin
			out <= 195;
		end
		else if (inp0 == 0 && inp1 == 13)
		begin
			out <= 196;
		end
		else if (inp0 == 3 && inp1 == 8)
		begin
			out <= 197;
		end
		else if (inp0 == 1 && inp1 == 108)
		begin
			out <= 198;
		end
		else if (inp0 == 0 && inp1 == 83)
		begin
			out <= 199;
		end
		else if (inp0 == 3 && inp1 == 56)
		begin
			out <= 200;
		end
		else if (inp0 == 1 && inp1 == 33)
		begin
			out <= 201;
		end
		else if (inp0 == 3 && inp1 == 40)
		begin
			out <= 202;
		end
		else if (inp0 == 1 && inp1 == 46)
		begin
			out <= 203;
		end
		else if (inp0 == 3 && inp1 == 38)
		begin
			out <= 204;
		end
		else if (inp0 == 1 && inp1 == 106)
		begin
			out <= 205;
		end
		else if (inp0 == 1 && inp1 == 48)
		begin
			out <= 206;
		end
		else if (inp0 == 2 && inp1 == 64)
		begin
			out <= 207;
		end
		else if (inp0 == 1 && inp1 == 0)
		begin
			out <= 208;
		end
		else if (inp0 == 1 && inp1 == 64)
		begin
			out <= 209;
		end
		else if (inp0 == 3 && inp1 == 42)
		begin
			out <= 210;
		end
		else if (inp0 == 0 && inp1 == 112)
		begin
			out <= 211;
		end
		else if (inp0 == 3 && inp1 == 116)
		begin
			out <= 212;
		end
		else if (inp0 == 3 && inp1 == 78)
		begin
			out <= 213;
		end
		else if (inp0 == 1 && inp1 == 35)
		begin
			out <= 214;
		end
		else if (inp0 == 2 && inp1 == 21)
		begin
			out <= 215;
		end
		else if (inp0 == 2 && inp1 == 30)
		begin
			out <= 216;
		end
		else if (inp0 == 2 && inp1 == 61)
		begin
			out <= 217;
		end
		else if (inp0 == 3 && inp1 == 58)
		begin
			out <= 218;
		end
		else if (inp0 == 3 && inp1 == 68)
		begin
			out <= 219;
		end
		else if (inp0 == 2 && inp1 == 54)
		begin
			out <= 220;
		end
		else if (inp0 == 1 && inp1 == 23)
		begin
			out <= 221;
		end
		else if (inp0 == 0 && inp1 == 85)
		begin
			out <= 222;
		end
		else if (inp0 == 2 && inp1 == 86)
		begin
			out <= 223;
		end
		else if (inp0 == 0 && inp1 == 74)
		begin
			out <= 224;
		end
		else if (inp0 == 2 && inp1 == 71)
		begin
			out <= 225;
		end
		else if (inp0 == 1 && inp1 == 110)
		begin
			out <= 226;
		end
		else if (inp0 == 1 && inp1 == 51)
		begin
			out <= 227;
		end
		else if (inp0 == 2 && inp1 == 113)
		begin
			out <= 228;
		end
		else if (inp0 == 2 && inp1 == 35)
		begin
			out <= 229;
		end
		else if (inp0 == 3 && inp1 == 10)
		begin
			out <= 230;
		end
		else if (inp0 == 2 && inp1 == 40)
		begin
			out <= 231;
		end
		else if (inp0 == 1 && inp1 == 107)
		begin
			out <= 232;
		end
		else if (inp0 == 1 && inp1 == 57)
		begin
			out <= 233;
		end
		else if (inp0 == 0 && inp1 == 15)
		begin
			out <= 234;
		end
		else if (inp0 == 3 && inp1 == 4)
		begin
			out <= 235;
		end
		else if (inp0 == 3 && inp1 == 74)
		begin
			out <= 236;
		end
		else if (inp0 == 2 && inp1 == 31)
		begin
			out <= 237;
		end
		else if (inp0 == 0 && inp1 == 97)
		begin
			out <= 238;
		end
		else if (inp0 == 0 && inp1 == 118)
		begin
			out <= 239;
		end
		else if (inp0 == 3 && inp1 == 103)
		begin
			out <= 240;
		end
		else if (inp0 == 0 && inp1 == 26)
		begin
			out <= 241;
		end
		else if (inp0 == 1 && inp1 == 52)
		begin
			out <= 242;
		end
		else if (inp0 == 1 && inp1 == 45)
		begin
			out <= 243;
		end
		else if (inp0 == 1 && inp1 == 77)
		begin
			out <= 244;
		end
		else if (inp0 == 0 && inp1 == 101)
		begin
			out <= 245;
		end
		else if (inp0 == 1 && inp1 == 26)
		begin
			out <= 246;
		end
		else if (inp0 == 0 && inp1 == 98)
		begin
			out <= 247;
		end
		else if (inp0 == 2 && inp1 == 122)
		begin
			out <= 248;
		end
		else if (inp0 == 3 && inp1 == 88)
		begin
			out <= 249;
		end
		else if (inp0 == 3 && inp1 == 17)
		begin
			out <= 250;
		end
		else if (inp0 == 0 && inp1 == 68)
		begin
			out <= 251;
		end
		else if (inp0 == 3 && inp1 == 89)
		begin
			out <= 252;
		end
		else if (inp0 == 2 && inp1 == 8)
		begin
			out <= 253;
		end
		else if (inp0 == 1 && inp1 == 126)
		begin
			out <= 254;
		end
		else if (inp0 == 3 && inp1 == 126)
		begin
			out <= 255;
		end
		else if (inp0 == 0 && inp1 == 8)
		begin
			out <= 256;
		end
		else if (inp0 == 1 && inp1 == 89)
		begin
			out <= 257;
		end
		else if (inp0 == 2 && inp1 == 68)
		begin
			out <= 258;
		end
		else if (inp0 == 1 && inp1 == 17)
		begin
			out <= 259;
		end
		else if (inp0 == 1 && inp1 == 88)
		begin
			out <= 260;
		end
		else if (inp0 == 0 && inp1 == 122)
		begin
			out <= 261;
		end
		else if (inp0 == 2 && inp1 == 98)
		begin
			out <= 262;
		end
		else if (inp0 == 3 && inp1 == 26)
		begin
			out <= 263;
		end
		else if (inp0 == 2 && inp1 == 101)
		begin
			out <= 264;
		end
		else if (inp0 == 3 && inp1 == 77)
		begin
			out <= 265;
		end
		else if (inp0 == 3 && inp1 == 45)
		begin
			out <= 266;
		end
		else if (inp0 == 3 && inp1 == 52)
		begin
			out <= 267;
		end
		else if (inp0 == 2 && inp1 == 26)
		begin
			out <= 268;
		end
		else if (inp0 == 1 && inp1 == 103)
		begin
			out <= 269;
		end
		else if (inp0 == 2 && inp1 == 118)
		begin
			out <= 270;
		end
		else if (inp0 == 2 && inp1 == 97)
		begin
			out <= 271;
		end
		else if (inp0 == 0 && inp1 == 31)
		begin
			out <= 272;
		end
		else if (inp0 == 1 && inp1 == 74)
		begin
			out <= 273;
		end
		else if (inp0 == 1 && inp1 == 4)
		begin
			out <= 274;
		end
		else if (inp0 == 2 && inp1 == 15)
		begin
			out <= 275;
		end
		else if (inp0 == 3 && inp1 == 57)
		begin
			out <= 276;
		end
		else if (inp0 == 3 && inp1 == 107)
		begin
			out <= 277;
		end
		else if (inp0 == 0 && inp1 == 40)
		begin
			out <= 278;
		end
		else if (inp0 == 1 && inp1 == 10)
		begin
			out <= 279;
		end
		else if (inp0 == 0 && inp1 == 35)
		begin
			out <= 280;
		end
		else if (inp0 == 0 && inp1 == 113)
		begin
			out <= 281;
		end
		else if (inp0 == 3 && inp1 == 51)
		begin
			out <= 282;
		end
		else if (inp0 == 3 && inp1 == 110)
		begin
			out <= 283;
		end
		else if (inp0 == 0 && inp1 == 71)
		begin
			out <= 284;
		end
		else if (inp0 == 2 && inp1 == 74)
		begin
			out <= 285;
		end
		else if (inp0 == 0 && inp1 == 86)
		begin
			out <= 286;
		end
		else if (inp0 == 2 && inp1 == 85)
		begin
			out <= 287;
		end
		else if (inp0 == 3 && inp1 == 23)
		begin
			out <= 288;
		end
		else if (inp0 == 0 && inp1 == 54)
		begin
			out <= 289;
		end
		else if (inp0 == 1 && inp1 == 68)
		begin
			out <= 290;
		end
		else if (inp0 == 1 && inp1 == 58)
		begin
			out <= 291;
		end
		else if (inp0 == 0 && inp1 == 61)
		begin
			out <= 292;
		end
		else if (inp0 == 0 && inp1 == 30)
		begin
			out <= 293;
		end
		else if (inp0 == 0 && inp1 == 21)
		begin
			out <= 294;
		end
		else if (inp0 == 3 && inp1 == 35)
		begin
			out <= 295;
		end
		else if (inp0 == 1 && inp1 == 78)
		begin
			out <= 296;
		end
		else if (inp0 == 1 && inp1 == 116)
		begin
			out <= 297;
		end
		else if (inp0 == 2 && inp1 == 112)
		begin
			out <= 298;
		end
		else if (inp0 == 1 && inp1 == 42)
		begin
			out <= 299;
		end
		else if (inp0 == 3 && inp1 == 64)
		begin
			out <= 300;
		end
		else if (inp0 == 3 && inp1 == 0)
		begin
			out <= 301;
		end
		else if (inp0 == 0 && inp1 == 64)
		begin
			out <= 302;
		end
		else if (inp0 == 3 && inp1 == 48)
		begin
			out <= 303;
		end
		else if (inp0 == 3 && inp1 == 106)
		begin
			out <= 304;
		end
		else if (inp0 == 1 && inp1 == 38)
		begin
			out <= 305;
		end
		else if (inp0 == 3 && inp1 == 46)
		begin
			out <= 306;
		end
		else if (inp0 == 1 && inp1 == 40)
		begin
			out <= 307;
		end
		else if (inp0 == 3 && inp1 == 33)
		begin
			out <= 308;
		end
		else if (inp0 == 1 && inp1 == 56)
		begin
			out <= 309;
		end
		else if (inp0 == 2 && inp1 == 83)
		begin
			out <= 310;
		end
		else if (inp0 == 3 && inp1 == 108)
		begin
			out <= 311;
		end
		else if (inp0 == 1 && inp1 == 8)
		begin
			out <= 312;
		end
		else if (inp0 == 2 && inp1 == 13)
		begin
			out <= 313;
		end
		else if (inp0 == 2 && inp1 == 95)
		begin
			out <= 314;
		end
		else if (inp0 == 3 && inp1 == 50)
		begin
			out <= 315;
		end
		else if (inp0 == 3 && inp1 == 24)
		begin
			out <= 316;
		end
		else if (inp0 == 1 && inp1 == 15)
		begin
			out <= 317;
		end
		else if (inp0 == 3 && inp1 == 124)
		begin
			out <= 318;
		end
		else if (inp0 == 0 && inp1 == 66)
		begin
			out <= 319;
		end
		else if (inp0 == 0 && inp1 == 96)
		begin
			out <= 320;
		end
		else if (inp0 == 1 && inp1 == 43)
		begin
			out <= 321;
		end
		else if (inp0 == 0 && inp1 == 116)
		begin
			out <= 322;
		end
		else if (inp0 == 3 && inp1 == 2)
		begin
			out <= 323;
		end
		else if (inp0 == 2 && inp1 == 38)
		begin
			out <= 324;
		end
		else if (inp0 == 1 && inp1 == 49)
		begin
			out <= 325;
		end
		else if (inp0 == 2 && inp1 == 84)
		begin
			out <= 326;
		end
		else if (inp0 == 3 && inp1 == 66)
		begin
			out <= 327;
		end
		else if (inp0 == 2 && inp1 == 19)
		begin
			out <= 328;
		end
		else if (inp0 == 0 && inp1 == 110)
		begin
			out <= 329;
		end
		else if (inp0 == 2 && inp1 == 62)
		begin
			out <= 330;
		end
		else if (inp0 == 1 && inp1 == 44)
		begin
			out <= 331;
		end
		else if (inp0 == 0 && inp1 == 81)
		begin
			out <= 332;
		end
		else if (inp0 == 0 && inp1 == 93)
		begin
			out <= 333;
		end
		else if (inp0 == 1 && inp1 == 122)
		begin
			out <= 334;
		end
		else if (inp0 == 2 && inp1 == 114)
		begin
			out <= 335;
		end
		else if (inp0 == 0 && inp1 == 82)
		begin
			out <= 336;
		end
		else if (inp0 == 0 && inp1 == 60)
		begin
			out <= 337;
		end
		else if (inp0 == 3 && inp1 == 120)
		begin
			out <= 338;
		end
		else if (inp0 == 1 && inp1 == 118)
		begin
			out <= 339;
		end
		else if (inp0 == 0 && inp1 == 119)
		begin
			out <= 340;
		end
		else if (inp0 == 1 && inp1 == 81)
		begin
			out <= 341;
		end
		else if (inp0 == 2 && inp1 == 121)
		begin
			out <= 342;
		end
		else if (inp0 == 1 && inp1 == 80)
		begin
			out <= 343;
		end
		else if (inp0 == 3 && inp1 == 61)
		begin
			out <= 344;
		end
		else if (inp0 == 3 && inp1 == 18)
		begin
			out <= 345;
		end
		else if (inp0 == 3 && inp1 == 83)
		begin
			out <= 346;
		end
		else if (inp0 == 3 && inp1 == 37)
		begin
			out <= 347;
		end
		else if (inp0 == 1 && inp1 == 115)
		begin
			out <= 348;
		end
		else if (inp0 == 1 && inp1 == 95)
		begin
			out <= 349;
		end
		else if (inp0 == 0 && inp1 == 123)
		begin
			out <= 350;
		end
		else if (inp0 == 0 && inp1 == 23)
		begin
			out <= 351;
		end
		else if (inp0 == 3 && inp1 == 94)
		begin
			out <= 352;
		end
		else if (inp0 == 2 && inp1 == 7)
		begin
			out <= 353;
		end
		else if (inp0 == 3 && inp1 == 82)
		begin
			out <= 354;
		end
		else if (inp0 == 0 && inp1 == 32)
		begin
			out <= 355;
		end
		else if (inp0 == 0 && inp1 == 45)
		begin
			out <= 356;
		end
		else if (inp0 == 0 && inp1 == 105)
		begin
			out <= 357;
		end
		else if (inp0 == 1 && inp1 == 63)
		begin
			out <= 358;
		end
		else if (inp0 == 0 && inp1 == 63)
		begin
			out <= 359;
		end
		else if (inp0 == 3 && inp1 == 111)
		begin
			out <= 360;
		end
		else if (inp0 == 2 && inp1 == 77)
		begin
			out <= 361;
		end
		else if (inp0 == 1 && inp1 == 20)
		begin
			out <= 362;
		end
		else if (inp0 == 1 && inp1 == 60)
		begin
			out <= 363;
		end
		else if (inp0 == 2 && inp1 == 67)
		begin
			out <= 364;
		end
		else if (inp0 == 0 && inp1 == 22)
		begin
			out <= 365;
		end
		else if (inp0 == 1 && inp1 == 85)
		begin
			out <= 366;
		end
		else if (inp0 == 1 && inp1 == 70)
		begin
			out <= 367;
		end
		else if (inp0 == 0 && inp1 == 50)
		begin
			out <= 368;
		end
		else if (inp0 == 1 && inp1 == 34)
		begin
			out <= 369;
		end
		else if (inp0 == 1 && inp1 == 39)
		begin
			out <= 370;
		end
		else if (inp0 == 0 && inp1 == 56)
		begin
			out <= 371;
		end
		else if (inp0 == 2 && inp1 == 3)
		begin
			out <= 372;
		end
		else if (inp0 == 1 && inp1 == 30)
		begin
			out <= 373;
		end
		else if (inp0 == 3 && inp1 == 117)
		begin
			out <= 374;
		end
		else if (inp0 == 3 && inp1 == 25)
		begin
			out <= 375;
		end
		else if (inp0 == 0 && inp1 == 44)
		begin
			out <= 376;
		end
		else if (inp0 == 3 && inp1 == 100)
		begin
			out <= 377;
		end
		else if (inp0 == 3 && inp1 == 97)
		begin
			out <= 378;
		end
		else if (inp0 == 2 && inp1 == 87)
		begin
			out <= 379;
		end
		else if (inp0 == 3 && inp1 == 67)
		begin
			out <= 380;
		end
		else if (inp0 == 1 && inp1 == 7)
		begin
			out <= 381;
		end
		else if (inp0 == 2 && inp1 == 125)
		begin
			out <= 382;
		end
		else if (inp0 == 0 && inp1 == 88)
		begin
			out <= 383;
		end
		else if (inp0 == 0 && inp1 == 16)
		begin
			out <= 384;
		end
		else if (inp0 == 3 && inp1 == 121)
		begin
			out <= 385;
		end
		else if (inp0 == 2 && inp1 == 25)
		begin
			out <= 386;
		end
		else if (inp0 == 2 && inp1 == 76)
		begin
			out <= 387;
		end
		else if (inp0 == 2 && inp1 == 51)
		begin
			out <= 388;
		end
		else if (inp0 == 0 && inp1 == 102)
		begin
			out <= 389;
		end
		else if (inp0 == 1 && inp1 == 96)
		begin
			out <= 390;
		end
		else if (inp0 == 0 && inp1 == 73)
		begin
			out <= 391;
		end
		else if (inp0 == 1 && inp1 == 14)
		begin
			out <= 392;
		end
		else if (inp0 == 2 && inp1 == 106)
		begin
			out <= 393;
		end
		else if (inp0 == 0 && inp1 == 9)
		begin
			out <= 394;
		end
		else if (inp0 == 3 && inp1 == 112)
		begin
			out <= 395;
		end
		else if (inp0 == 2 && inp1 == 109)
		begin
			out <= 396;
		end
		else if (inp0 == 1 && inp1 == 73)
		begin
			out <= 397;
		end
		else if (inp0 == 1 && inp1 == 84)
		begin
			out <= 398;
		end
		else if (inp0 == 3 && inp1 == 53)
		begin
			out <= 399;
		end
		else if (inp0 == 0 && inp1 == 57)
		begin
			out <= 400;
		end
		else if (inp0 == 3 && inp1 == 29)
		begin
			out <= 401;
		end
		else if (inp0 == 2 && inp1 == 34)
		begin
			out <= 402;
		end
		else if (inp0 == 0 && inp1 == 115)
		begin
			out <= 403;
		end
		else if (inp0 == 0 && inp1 == 41)
		begin
			out <= 404;
		end
		else if (inp0 == 2 && inp1 == 126)
		begin
			out <= 405;
		end
		else if (inp0 == 2 && inp1 == 47)
		begin
			out <= 406;
		end
		else if (inp0 == 0 && inp1 == 37)
		begin
			out <= 407;
		end
		else if (inp0 == 0 && inp1 == 39)
		begin
			out <= 408;
		end
		else if (inp0 == 0 && inp1 == 55)
		begin
			out <= 409;
		end
		else if (inp0 == 2 && inp1 == 107)
		begin
			out <= 410;
		end
		else if (inp0 == 1 && inp1 == 12)
		begin
			out <= 411;
		end
		else if (inp0 == 2 && inp1 == 49)
		begin
			out <= 412;
		end
		else if (inp0 == 0 && inp1 == 14)
		begin
			out <= 413;
		end
		else if (inp0 == 3 && inp1 == 65)
		begin
			out <= 414;
		end
		else if (inp0 == 0 && inp1 == 42)
		begin
			out <= 415;
		end
		else if (inp0 == 2 && inp1 == 1)
		begin
			out <= 416;
		end
		else if (inp0 == 0 && inp1 == 48)
		begin
			out <= 417;
		end
		else if (inp0 == 2 && inp1 == 65)
		begin
			out <= 418;
		end
		else if (inp0 == 3 && inp1 == 109)
		begin
			out <= 419;
		end
		else if (inp0 == 0 && inp1 == 43)
		begin
			out <= 420;
		end
		else if (inp0 == 3 && inp1 == 92)
		begin
			out <= 421;
		end
		else if (inp0 == 1 && inp1 == 113)
		begin
			out <= 422;
		end
		else if (inp0 == 3 && inp1 == 59)
		begin
			out <= 423;
		end
		else if (inp0 == 0 && inp1 == 117)
		begin
			out <= 424;
		end
		else if (inp0 == 0 && inp1 == 80)
		begin
			out <= 425;
		end
		else if (inp0 == 0 && inp1 == 79)
		begin
			out <= 426;
		end
		else if (inp0 == 2 && inp1 == 17)
		begin
			out <= 427;
		end
		else if (inp0 == 2 && inp1 == 36)
		begin
			out <= 428;
		end
		else if (inp0 == 0 && inp1 == 94)
		begin
			out <= 429;
		end
		else if (inp0 == 3 && inp1 == 22)
		begin
			out <= 430;
		end
		else if (inp0 == 1 && inp1 == 6)
		begin
			out <= 431;
		end
		else if (inp0 == 3 && inp1 == 31)
		begin
			out <= 432;
		end
		else if (inp0 == 3 && inp1 == 104)
		begin
			out <= 433;
		end
		else if (inp0 == 3 && inp1 == 62)
		begin
			out <= 434;
		end
		else if (inp0 == 1 && inp1 == 76)
		begin
			out <= 435;
		end
		else if (inp0 == 0 && inp1 == 59)
		begin
			out <= 436;
		end
		else if (inp0 == 3 && inp1 == 21)
		begin
			out <= 437;
		end
		else if (inp0 == 0 && inp1 == 69)
		begin
			out <= 438;
		end
		else if (inp0 == 0 && inp1 == 33)
		begin
			out <= 439;
		end
		else if (inp0 == 3 && inp1 == 55)
		begin
			out <= 440;
		end
		else if (inp0 == 0 && inp1 == 29)
		begin
			out <= 441;
		end
		else if (inp0 == 2 && inp1 == 24)
		begin
			out <= 442;
		end
		else if (inp0 == 2 && inp1 == 99)
		begin
			out <= 443;
		end
		else if (inp0 == 1 && inp1 == 86)
		begin
			out <= 444;
		end
		else if (inp0 == 0 && inp1 == 6)
		begin
			out <= 445;
		end
		else if (inp0 == 3 && inp1 == 87)
		begin
			out <= 446;
		end
		else if (inp0 == 2 && inp1 == 120)
		begin
			out <= 447;
		end
		else if (inp0 == 1 && inp1 == 75)
		begin
			out <= 448;
		end
		else if (inp0 == 3 && inp1 == 101)
		begin
			out <= 449;
		end
		else if (inp0 == 3 && inp1 == 72)
		begin
			out <= 450;
		end
		else if (inp0 == 1 && inp1 == 105)
		begin
			out <= 451;
		end
		else if (inp0 == 2 && inp1 == 111)
		begin
			out <= 452;
		end
		else if (inp0 == 0 && inp1 == 72)
		begin
			out <= 453;
		end
		else if (inp0 == 2 && inp1 == 52)
		begin
			out <= 454;
		end
		else if (inp0 == 2 && inp1 == 28)
		begin
			out <= 455;
		end
		else if (inp0 == 3 && inp1 == 114)
		begin
			out <= 456;
		end
		else if (inp0 == 1 && inp1 == 125)
		begin
			out <= 457;
		end
		else if (inp0 == 3 && inp1 == 36)
		begin
			out <= 458;
		end
		else if (inp0 == 3 && inp1 == 54)
		begin
			out <= 459;
		end
		else if (inp0 == 0 && inp1 == 11)
		begin
			out <= 460;
		end
		else if (inp0 == 3 && inp1 == 13)
		begin
			out <= 461;
		end
		else if (inp0 == 3 && inp1 == 41)
		begin
			out <= 462;
		end
		else if (inp0 == 3 && inp1 == 47)
		begin
			out <= 463;
		end
		else if (inp0 == 2 && inp1 == 108)
		begin
			out <= 464;
		end
		else if (inp0 == 2 && inp1 == 91)
		begin
			out <= 465;
		end
		else if (inp0 == 2 && inp1 == 58)
		begin
			out <= 466;
		end
		else if (inp0 == 3 && inp1 == 79)
		begin
			out <= 467;
		end
		else if (inp0 == 1 && inp1 == 16)
		begin
			out <= 468;
		end
		else if (inp0 == 3 && inp1 == 93)
		begin
			out <= 469;
		end
		else if (inp0 == 0 && inp1 == 5)
		begin
			out <= 470;
		end
		else if (inp0 == 2 && inp1 == 103)
		begin
			out <= 471;
		end
		else if (inp0 == 0 && inp1 == 75)
		begin
			out <= 472;
		end
		else if (inp0 == 2 && inp1 == 20)
		begin
			out <= 473;
		end
		else if (inp0 == 3 && inp1 == 32)
		begin
			out <= 474;
		end
		else if (inp0 == 3 && inp1 == 28)
		begin
			out <= 475;
		end
		else if (inp0 == 1 && inp1 == 98)
		begin
			out <= 476;
		end
		else if (inp0 == 3 && inp1 == 5)
		begin
			out <= 477;
		end
		else if (inp0 == 1 && inp1 == 119)
		begin
			out <= 478;
		end
		else if (inp0 == 2 && inp1 == 100)
		begin
			out <= 479;
		end
		else if (inp0 == 0 && inp1 == 104)
		begin
			out <= 480;
		end
		else if (inp0 == 3 && inp1 == 71)
		begin
			out <= 481;
		end
		else if (inp0 == 1 && inp1 == 27)
		begin
			out <= 482;
		end
		else if (inp0 == 0 && inp1 == 124)
		begin
			out <= 483;
		end
		else if (inp0 == 2 && inp1 == 53)
		begin
			out <= 484;
		end
		else if (inp0 == 2 && inp1 == 12)
		begin
			out <= 485;
		end
		else if (inp0 == 2 && inp1 == 46)
		begin
			out <= 486;
		end
		else if (inp0 == 1 && inp1 == 90)
		begin
			out <= 487;
		end
		else if (inp0 == 2 && inp1 == 78)
		begin
			out <= 488;
		end
		else if (inp0 == 2 && inp1 == 92)
		begin
			out <= 489;
		end
		else if (inp0 == 1 && inp1 == 102)
		begin
			out <= 490;
		end
		else if (inp0 == 1 && inp1 == 19)
		begin
			out <= 491;
		end
		else if (inp0 == 2 && inp1 == 27)
		begin
			out <= 492;
		end
		else if (inp0 == 2 && inp1 == 4)
		begin
			out <= 493;
		end
		else if (inp0 == 1 && inp1 == 99)
		begin
			out <= 494;
		end
		else if (inp0 == 2 && inp1 == 70)
		begin
			out <= 495;
		end
		else if (inp0 == 3 && inp1 == 123)
		begin
			out <= 496;
		end
		else if (inp0 == 1 && inp1 == 11)
		begin
			out <= 497;
		end
		else if (inp0 == 0 && inp1 == 89)
		begin
			out <= 498;
		end
		else if (inp0 == 1 && inp1 == 91)
		begin
			out <= 499;
		end
		else if (inp0 == 0 && inp1 == 18)
		begin
			out <= 500;
		end
		else if (inp0 == 1 && inp1 == 3)
		begin
			out <= 501;
		end
		else if (inp0 == 1 && inp1 == 69)
		begin
			out <= 502;
		end
		else if (inp0 == 0 && inp1 == 10)
		begin
			out <= 503;
		end
		else if (inp0 == 0 && inp1 == 90)
		begin
			out <= 504;
		end
		else if (inp0 == 0 && inp1 == 2)
		begin
			out <= 505;
		end
		else if (inp0 == 3 && inp1 == 9)
		begin
			out <= 506;
		end
		else if (inp0 == 3 && inp1 == 1)
		begin
			out <= 507;
		end
		else if (inp0 == 2 && inp1 == 0)
		begin
			out <= 508;
		end
		else 
		begin
			out <= 0;
		end
	end
endmodule

module lut_input_509(inp, out0, out1);
	input [8:0] inp;
	output reg [2:0] out0;
	output reg [6:0] out1;
	always @ (inp)
	begin
		case(inp)
		1:
		begin
			out0 <= 0;
			out1 <= 0;
		end
		2:
		begin
			out0 <= 1;
			out1 <= 1;
		end
		3:
		begin
			out0 <= 1;
			out1 <= 9;
		end
		4:
		begin
			out0 <= 2;
			out1 <= 2;
		end
		5:
		begin
			out0 <= 2;
			out1 <= 90;
		end
		6:
		begin
			out0 <= 2;
			out1 <= 10;
		end
		7:
		begin
			out0 <= 3;
			out1 <= 69;
		end
		8:
		begin
			out0 <= 3;
			out1 <= 3;
		end
		9:
		begin
			out0 <= 2;
			out1 <= 18;
		end
		10:
		begin
			out0 <= 3;
			out1 <= 91;
		end
		11:
		begin
			out0 <= 2;
			out1 <= 89;
		end
		12:
		begin
			out0 <= 3;
			out1 <= 11;
		end
		13:
		begin
			out0 <= 1;
			out1 <= 123;
		end
		14:
		begin
			out0 <= 0;
			out1 <= 70;
		end
		15:
		begin
			out0 <= 3;
			out1 <= 99;
		end
		16:
		begin
			out0 <= 0;
			out1 <= 4;
		end
		17:
		begin
			out0 <= 0;
			out1 <= 27;
		end
		18:
		begin
			out0 <= 3;
			out1 <= 19;
		end
		19:
		begin
			out0 <= 3;
			out1 <= 102;
		end
		20:
		begin
			out0 <= 0;
			out1 <= 92;
		end
		21:
		begin
			out0 <= 0;
			out1 <= 78;
		end
		22:
		begin
			out0 <= 3;
			out1 <= 90;
		end
		23:
		begin
			out0 <= 0;
			out1 <= 46;
		end
		24:
		begin
			out0 <= 0;
			out1 <= 12;
		end
		25:
		begin
			out0 <= 0;
			out1 <= 53;
		end
		26:
		begin
			out0 <= 2;
			out1 <= 124;
		end
		27:
		begin
			out0 <= 3;
			out1 <= 27;
		end
		28:
		begin
			out0 <= 1;
			out1 <= 71;
		end
		29:
		begin
			out0 <= 2;
			out1 <= 104;
		end
		30:
		begin
			out0 <= 0;
			out1 <= 100;
		end
		31:
		begin
			out0 <= 3;
			out1 <= 119;
		end
		32:
		begin
			out0 <= 1;
			out1 <= 5;
		end
		33:
		begin
			out0 <= 3;
			out1 <= 98;
		end
		34:
		begin
			out0 <= 1;
			out1 <= 28;
		end
		35:
		begin
			out0 <= 1;
			out1 <= 32;
		end
		36:
		begin
			out0 <= 0;
			out1 <= 20;
		end
		37:
		begin
			out0 <= 2;
			out1 <= 75;
		end
		38:
		begin
			out0 <= 0;
			out1 <= 103;
		end
		39:
		begin
			out0 <= 2;
			out1 <= 5;
		end
		40:
		begin
			out0 <= 1;
			out1 <= 93;
		end
		41:
		begin
			out0 <= 3;
			out1 <= 16;
		end
		42:
		begin
			out0 <= 1;
			out1 <= 79;
		end
		43:
		begin
			out0 <= 0;
			out1 <= 58;
		end
		44:
		begin
			out0 <= 0;
			out1 <= 91;
		end
		45:
		begin
			out0 <= 0;
			out1 <= 108;
		end
		46:
		begin
			out0 <= 1;
			out1 <= 47;
		end
		47:
		begin
			out0 <= 1;
			out1 <= 41;
		end
		48:
		begin
			out0 <= 1;
			out1 <= 13;
		end
		49:
		begin
			out0 <= 2;
			out1 <= 11;
		end
		50:
		begin
			out0 <= 1;
			out1 <= 54;
		end
		51:
		begin
			out0 <= 1;
			out1 <= 36;
		end
		52:
		begin
			out0 <= 3;
			out1 <= 125;
		end
		53:
		begin
			out0 <= 1;
			out1 <= 114;
		end
		54:
		begin
			out0 <= 0;
			out1 <= 28;
		end
		55:
		begin
			out0 <= 0;
			out1 <= 52;
		end
		56:
		begin
			out0 <= 2;
			out1 <= 72;
		end
		57:
		begin
			out0 <= 0;
			out1 <= 111;
		end
		58:
		begin
			out0 <= 3;
			out1 <= 105;
		end
		59:
		begin
			out0 <= 1;
			out1 <= 72;
		end
		60:
		begin
			out0 <= 1;
			out1 <= 101;
		end
		61:
		begin
			out0 <= 3;
			out1 <= 75;
		end
		62:
		begin
			out0 <= 0;
			out1 <= 120;
		end
		63:
		begin
			out0 <= 1;
			out1 <= 87;
		end
		64:
		begin
			out0 <= 2;
			out1 <= 6;
		end
		65:
		begin
			out0 <= 3;
			out1 <= 86;
		end
		66:
		begin
			out0 <= 0;
			out1 <= 99;
		end
		67:
		begin
			out0 <= 0;
			out1 <= 24;
		end
		68:
		begin
			out0 <= 2;
			out1 <= 29;
		end
		69:
		begin
			out0 <= 1;
			out1 <= 55;
		end
		70:
		begin
			out0 <= 2;
			out1 <= 33;
		end
		71:
		begin
			out0 <= 2;
			out1 <= 69;
		end
		72:
		begin
			out0 <= 1;
			out1 <= 21;
		end
		73:
		begin
			out0 <= 2;
			out1 <= 59;
		end
		74:
		begin
			out0 <= 3;
			out1 <= 76;
		end
		75:
		begin
			out0 <= 1;
			out1 <= 62;
		end
		76:
		begin
			out0 <= 1;
			out1 <= 104;
		end
		77:
		begin
			out0 <= 1;
			out1 <= 31;
		end
		78:
		begin
			out0 <= 3;
			out1 <= 6;
		end
		79:
		begin
			out0 <= 1;
			out1 <= 22;
		end
		80:
		begin
			out0 <= 2;
			out1 <= 94;
		end
		81:
		begin
			out0 <= 0;
			out1 <= 36;
		end
		82:
		begin
			out0 <= 0;
			out1 <= 17;
		end
		83:
		begin
			out0 <= 2;
			out1 <= 79;
		end
		84:
		begin
			out0 <= 2;
			out1 <= 80;
		end
		85:
		begin
			out0 <= 2;
			out1 <= 117;
		end
		86:
		begin
			out0 <= 1;
			out1 <= 59;
		end
		87:
		begin
			out0 <= 3;
			out1 <= 113;
		end
		88:
		begin
			out0 <= 1;
			out1 <= 92;
		end
		89:
		begin
			out0 <= 2;
			out1 <= 43;
		end
		90:
		begin
			out0 <= 1;
			out1 <= 109;
		end
		91:
		begin
			out0 <= 0;
			out1 <= 65;
		end
		92:
		begin
			out0 <= 2;
			out1 <= 48;
		end
		93:
		begin
			out0 <= 0;
			out1 <= 1;
		end
		94:
		begin
			out0 <= 2;
			out1 <= 42;
		end
		95:
		begin
			out0 <= 1;
			out1 <= 65;
		end
		96:
		begin
			out0 <= 2;
			out1 <= 14;
		end
		97:
		begin
			out0 <= 0;
			out1 <= 49;
		end
		98:
		begin
			out0 <= 3;
			out1 <= 12;
		end
		99:
		begin
			out0 <= 0;
			out1 <= 107;
		end
		100:
		begin
			out0 <= 2;
			out1 <= 55;
		end
		101:
		begin
			out0 <= 2;
			out1 <= 39;
		end
		102:
		begin
			out0 <= 2;
			out1 <= 37;
		end
		103:
		begin
			out0 <= 0;
			out1 <= 47;
		end
		104:
		begin
			out0 <= 0;
			out1 <= 126;
		end
		105:
		begin
			out0 <= 2;
			out1 <= 41;
		end
		106:
		begin
			out0 <= 2;
			out1 <= 115;
		end
		107:
		begin
			out0 <= 0;
			out1 <= 34;
		end
		108:
		begin
			out0 <= 1;
			out1 <= 29;
		end
		109:
		begin
			out0 <= 2;
			out1 <= 57;
		end
		110:
		begin
			out0 <= 1;
			out1 <= 53;
		end
		111:
		begin
			out0 <= 3;
			out1 <= 84;
		end
		112:
		begin
			out0 <= 3;
			out1 <= 73;
		end
		113:
		begin
			out0 <= 0;
			out1 <= 109;
		end
		114:
		begin
			out0 <= 1;
			out1 <= 112;
		end
		115:
		begin
			out0 <= 2;
			out1 <= 9;
		end
		116:
		begin
			out0 <= 0;
			out1 <= 106;
		end
		117:
		begin
			out0 <= 3;
			out1 <= 14;
		end
		118:
		begin
			out0 <= 2;
			out1 <= 73;
		end
		119:
		begin
			out0 <= 3;
			out1 <= 96;
		end
		120:
		begin
			out0 <= 2;
			out1 <= 102;
		end
		121:
		begin
			out0 <= 0;
			out1 <= 51;
		end
		122:
		begin
			out0 <= 0;
			out1 <= 76;
		end
		123:
		begin
			out0 <= 0;
			out1 <= 25;
		end
		124:
		begin
			out0 <= 1;
			out1 <= 121;
		end
		125:
		begin
			out0 <= 2;
			out1 <= 16;
		end
		126:
		begin
			out0 <= 2;
			out1 <= 88;
		end
		127:
		begin
			out0 <= 0;
			out1 <= 125;
		end
		128:
		begin
			out0 <= 3;
			out1 <= 7;
		end
		129:
		begin
			out0 <= 1;
			out1 <= 67;
		end
		130:
		begin
			out0 <= 0;
			out1 <= 87;
		end
		131:
		begin
			out0 <= 1;
			out1 <= 97;
		end
		132:
		begin
			out0 <= 1;
			out1 <= 100;
		end
		133:
		begin
			out0 <= 2;
			out1 <= 44;
		end
		134:
		begin
			out0 <= 1;
			out1 <= 25;
		end
		135:
		begin
			out0 <= 1;
			out1 <= 117;
		end
		136:
		begin
			out0 <= 3;
			out1 <= 30;
		end
		137:
		begin
			out0 <= 0;
			out1 <= 3;
		end
		138:
		begin
			out0 <= 2;
			out1 <= 56;
		end
		139:
		begin
			out0 <= 3;
			out1 <= 39;
		end
		140:
		begin
			out0 <= 3;
			out1 <= 34;
		end
		141:
		begin
			out0 <= 2;
			out1 <= 50;
		end
		142:
		begin
			out0 <= 3;
			out1 <= 70;
		end
		143:
		begin
			out0 <= 3;
			out1 <= 85;
		end
		144:
		begin
			out0 <= 2;
			out1 <= 22;
		end
		145:
		begin
			out0 <= 0;
			out1 <= 67;
		end
		146:
		begin
			out0 <= 3;
			out1 <= 60;
		end
		147:
		begin
			out0 <= 3;
			out1 <= 20;
		end
		148:
		begin
			out0 <= 0;
			out1 <= 77;
		end
		149:
		begin
			out0 <= 1;
			out1 <= 111;
		end
		150:
		begin
			out0 <= 2;
			out1 <= 63;
		end
		151:
		begin
			out0 <= 3;
			out1 <= 63;
		end
		152:
		begin
			out0 <= 2;
			out1 <= 105;
		end
		153:
		begin
			out0 <= 2;
			out1 <= 45;
		end
		154:
		begin
			out0 <= 2;
			out1 <= 32;
		end
		155:
		begin
			out0 <= 1;
			out1 <= 82;
		end
		156:
		begin
			out0 <= 0;
			out1 <= 7;
		end
		157:
		begin
			out0 <= 1;
			out1 <= 94;
		end
		158:
		begin
			out0 <= 2;
			out1 <= 23;
		end
		159:
		begin
			out0 <= 2;
			out1 <= 123;
		end
		160:
		begin
			out0 <= 3;
			out1 <= 95;
		end
		161:
		begin
			out0 <= 3;
			out1 <= 115;
		end
		162:
		begin
			out0 <= 1;
			out1 <= 37;
		end
		163:
		begin
			out0 <= 1;
			out1 <= 83;
		end
		164:
		begin
			out0 <= 1;
			out1 <= 18;
		end
		165:
		begin
			out0 <= 1;
			out1 <= 61;
		end
		166:
		begin
			out0 <= 3;
			out1 <= 80;
		end
		167:
		begin
			out0 <= 0;
			out1 <= 121;
		end
		168:
		begin
			out0 <= 3;
			out1 <= 81;
		end
		169:
		begin
			out0 <= 2;
			out1 <= 119;
		end
		170:
		begin
			out0 <= 3;
			out1 <= 118;
		end
		171:
		begin
			out0 <= 1;
			out1 <= 120;
		end
		172:
		begin
			out0 <= 2;
			out1 <= 60;
		end
		173:
		begin
			out0 <= 2;
			out1 <= 82;
		end
		174:
		begin
			out0 <= 0;
			out1 <= 114;
		end
		175:
		begin
			out0 <= 3;
			out1 <= 122;
		end
		176:
		begin
			out0 <= 2;
			out1 <= 93;
		end
		177:
		begin
			out0 <= 2;
			out1 <= 81;
		end
		178:
		begin
			out0 <= 3;
			out1 <= 44;
		end
		179:
		begin
			out0 <= 0;
			out1 <= 62;
		end
		180:
		begin
			out0 <= 2;
			out1 <= 110;
		end
		181:
		begin
			out0 <= 0;
			out1 <= 19;
		end
		182:
		begin
			out0 <= 1;
			out1 <= 66;
		end
		183:
		begin
			out0 <= 0;
			out1 <= 84;
		end
		184:
		begin
			out0 <= 3;
			out1 <= 49;
		end
		185:
		begin
			out0 <= 0;
			out1 <= 38;
		end
		186:
		begin
			out0 <= 1;
			out1 <= 2;
		end
		187:
		begin
			out0 <= 2;
			out1 <= 116;
		end
		188:
		begin
			out0 <= 3;
			out1 <= 43;
		end
		189:
		begin
			out0 <= 2;
			out1 <= 96;
		end
		190:
		begin
			out0 <= 2;
			out1 <= 66;
		end
		191:
		begin
			out0 <= 1;
			out1 <= 124;
		end
		192:
		begin
			out0 <= 3;
			out1 <= 15;
		end
		193:
		begin
			out0 <= 1;
			out1 <= 24;
		end
		194:
		begin
			out0 <= 1;
			out1 <= 50;
		end
		195:
		begin
			out0 <= 0;
			out1 <= 95;
		end
		196:
		begin
			out0 <= 0;
			out1 <= 13;
		end
		197:
		begin
			out0 <= 3;
			out1 <= 8;
		end
		198:
		begin
			out0 <= 1;
			out1 <= 108;
		end
		199:
		begin
			out0 <= 0;
			out1 <= 83;
		end
		200:
		begin
			out0 <= 3;
			out1 <= 56;
		end
		201:
		begin
			out0 <= 1;
			out1 <= 33;
		end
		202:
		begin
			out0 <= 3;
			out1 <= 40;
		end
		203:
		begin
			out0 <= 1;
			out1 <= 46;
		end
		204:
		begin
			out0 <= 3;
			out1 <= 38;
		end
		205:
		begin
			out0 <= 1;
			out1 <= 106;
		end
		206:
		begin
			out0 <= 1;
			out1 <= 48;
		end
		207:
		begin
			out0 <= 2;
			out1 <= 64;
		end
		208:
		begin
			out0 <= 1;
			out1 <= 0;
		end
		209:
		begin
			out0 <= 1;
			out1 <= 64;
		end
		210:
		begin
			out0 <= 3;
			out1 <= 42;
		end
		211:
		begin
			out0 <= 0;
			out1 <= 112;
		end
		212:
		begin
			out0 <= 3;
			out1 <= 116;
		end
		213:
		begin
			out0 <= 3;
			out1 <= 78;
		end
		214:
		begin
			out0 <= 1;
			out1 <= 35;
		end
		215:
		begin
			out0 <= 2;
			out1 <= 21;
		end
		216:
		begin
			out0 <= 2;
			out1 <= 30;
		end
		217:
		begin
			out0 <= 2;
			out1 <= 61;
		end
		218:
		begin
			out0 <= 3;
			out1 <= 58;
		end
		219:
		begin
			out0 <= 3;
			out1 <= 68;
		end
		220:
		begin
			out0 <= 2;
			out1 <= 54;
		end
		221:
		begin
			out0 <= 1;
			out1 <= 23;
		end
		222:
		begin
			out0 <= 0;
			out1 <= 85;
		end
		223:
		begin
			out0 <= 2;
			out1 <= 86;
		end
		224:
		begin
			out0 <= 0;
			out1 <= 74;
		end
		225:
		begin
			out0 <= 2;
			out1 <= 71;
		end
		226:
		begin
			out0 <= 1;
			out1 <= 110;
		end
		227:
		begin
			out0 <= 1;
			out1 <= 51;
		end
		228:
		begin
			out0 <= 2;
			out1 <= 113;
		end
		229:
		begin
			out0 <= 2;
			out1 <= 35;
		end
		230:
		begin
			out0 <= 3;
			out1 <= 10;
		end
		231:
		begin
			out0 <= 2;
			out1 <= 40;
		end
		232:
		begin
			out0 <= 1;
			out1 <= 107;
		end
		233:
		begin
			out0 <= 1;
			out1 <= 57;
		end
		234:
		begin
			out0 <= 0;
			out1 <= 15;
		end
		235:
		begin
			out0 <= 3;
			out1 <= 4;
		end
		236:
		begin
			out0 <= 3;
			out1 <= 74;
		end
		237:
		begin
			out0 <= 2;
			out1 <= 31;
		end
		238:
		begin
			out0 <= 0;
			out1 <= 97;
		end
		239:
		begin
			out0 <= 0;
			out1 <= 118;
		end
		240:
		begin
			out0 <= 3;
			out1 <= 103;
		end
		241:
		begin
			out0 <= 0;
			out1 <= 26;
		end
		242:
		begin
			out0 <= 1;
			out1 <= 52;
		end
		243:
		begin
			out0 <= 1;
			out1 <= 45;
		end
		244:
		begin
			out0 <= 1;
			out1 <= 77;
		end
		245:
		begin
			out0 <= 0;
			out1 <= 101;
		end
		246:
		begin
			out0 <= 1;
			out1 <= 26;
		end
		247:
		begin
			out0 <= 0;
			out1 <= 98;
		end
		248:
		begin
			out0 <= 2;
			out1 <= 122;
		end
		249:
		begin
			out0 <= 3;
			out1 <= 88;
		end
		250:
		begin
			out0 <= 3;
			out1 <= 17;
		end
		251:
		begin
			out0 <= 0;
			out1 <= 68;
		end
		252:
		begin
			out0 <= 3;
			out1 <= 89;
		end
		253:
		begin
			out0 <= 2;
			out1 <= 8;
		end
		254:
		begin
			out0 <= 1;
			out1 <= 126;
		end
		255:
		begin
			out0 <= 3;
			out1 <= 126;
		end
		256:
		begin
			out0 <= 0;
			out1 <= 8;
		end
		257:
		begin
			out0 <= 1;
			out1 <= 89;
		end
		258:
		begin
			out0 <= 2;
			out1 <= 68;
		end
		259:
		begin
			out0 <= 1;
			out1 <= 17;
		end
		260:
		begin
			out0 <= 1;
			out1 <= 88;
		end
		261:
		begin
			out0 <= 0;
			out1 <= 122;
		end
		262:
		begin
			out0 <= 2;
			out1 <= 98;
		end
		263:
		begin
			out0 <= 3;
			out1 <= 26;
		end
		264:
		begin
			out0 <= 2;
			out1 <= 101;
		end
		265:
		begin
			out0 <= 3;
			out1 <= 77;
		end
		266:
		begin
			out0 <= 3;
			out1 <= 45;
		end
		267:
		begin
			out0 <= 3;
			out1 <= 52;
		end
		268:
		begin
			out0 <= 2;
			out1 <= 26;
		end
		269:
		begin
			out0 <= 1;
			out1 <= 103;
		end
		270:
		begin
			out0 <= 2;
			out1 <= 118;
		end
		271:
		begin
			out0 <= 2;
			out1 <= 97;
		end
		272:
		begin
			out0 <= 0;
			out1 <= 31;
		end
		273:
		begin
			out0 <= 1;
			out1 <= 74;
		end
		274:
		begin
			out0 <= 1;
			out1 <= 4;
		end
		275:
		begin
			out0 <= 2;
			out1 <= 15;
		end
		276:
		begin
			out0 <= 3;
			out1 <= 57;
		end
		277:
		begin
			out0 <= 3;
			out1 <= 107;
		end
		278:
		begin
			out0 <= 0;
			out1 <= 40;
		end
		279:
		begin
			out0 <= 1;
			out1 <= 10;
		end
		280:
		begin
			out0 <= 0;
			out1 <= 35;
		end
		281:
		begin
			out0 <= 0;
			out1 <= 113;
		end
		282:
		begin
			out0 <= 3;
			out1 <= 51;
		end
		283:
		begin
			out0 <= 3;
			out1 <= 110;
		end
		284:
		begin
			out0 <= 0;
			out1 <= 71;
		end
		285:
		begin
			out0 <= 2;
			out1 <= 74;
		end
		286:
		begin
			out0 <= 0;
			out1 <= 86;
		end
		287:
		begin
			out0 <= 2;
			out1 <= 85;
		end
		288:
		begin
			out0 <= 3;
			out1 <= 23;
		end
		289:
		begin
			out0 <= 0;
			out1 <= 54;
		end
		290:
		begin
			out0 <= 1;
			out1 <= 68;
		end
		291:
		begin
			out0 <= 1;
			out1 <= 58;
		end
		292:
		begin
			out0 <= 0;
			out1 <= 61;
		end
		293:
		begin
			out0 <= 0;
			out1 <= 30;
		end
		294:
		begin
			out0 <= 0;
			out1 <= 21;
		end
		295:
		begin
			out0 <= 3;
			out1 <= 35;
		end
		296:
		begin
			out0 <= 1;
			out1 <= 78;
		end
		297:
		begin
			out0 <= 1;
			out1 <= 116;
		end
		298:
		begin
			out0 <= 2;
			out1 <= 112;
		end
		299:
		begin
			out0 <= 1;
			out1 <= 42;
		end
		300:
		begin
			out0 <= 3;
			out1 <= 64;
		end
		301:
		begin
			out0 <= 3;
			out1 <= 0;
		end
		302:
		begin
			out0 <= 0;
			out1 <= 64;
		end
		303:
		begin
			out0 <= 3;
			out1 <= 48;
		end
		304:
		begin
			out0 <= 3;
			out1 <= 106;
		end
		305:
		begin
			out0 <= 1;
			out1 <= 38;
		end
		306:
		begin
			out0 <= 3;
			out1 <= 46;
		end
		307:
		begin
			out0 <= 1;
			out1 <= 40;
		end
		308:
		begin
			out0 <= 3;
			out1 <= 33;
		end
		309:
		begin
			out0 <= 1;
			out1 <= 56;
		end
		310:
		begin
			out0 <= 2;
			out1 <= 83;
		end
		311:
		begin
			out0 <= 3;
			out1 <= 108;
		end
		312:
		begin
			out0 <= 1;
			out1 <= 8;
		end
		313:
		begin
			out0 <= 2;
			out1 <= 13;
		end
		314:
		begin
			out0 <= 2;
			out1 <= 95;
		end
		315:
		begin
			out0 <= 3;
			out1 <= 50;
		end
		316:
		begin
			out0 <= 3;
			out1 <= 24;
		end
		317:
		begin
			out0 <= 1;
			out1 <= 15;
		end
		318:
		begin
			out0 <= 3;
			out1 <= 124;
		end
		319:
		begin
			out0 <= 0;
			out1 <= 66;
		end
		320:
		begin
			out0 <= 0;
			out1 <= 96;
		end
		321:
		begin
			out0 <= 1;
			out1 <= 43;
		end
		322:
		begin
			out0 <= 0;
			out1 <= 116;
		end
		323:
		begin
			out0 <= 3;
			out1 <= 2;
		end
		324:
		begin
			out0 <= 2;
			out1 <= 38;
		end
		325:
		begin
			out0 <= 1;
			out1 <= 49;
		end
		326:
		begin
			out0 <= 2;
			out1 <= 84;
		end
		327:
		begin
			out0 <= 3;
			out1 <= 66;
		end
		328:
		begin
			out0 <= 2;
			out1 <= 19;
		end
		329:
		begin
			out0 <= 0;
			out1 <= 110;
		end
		330:
		begin
			out0 <= 2;
			out1 <= 62;
		end
		331:
		begin
			out0 <= 1;
			out1 <= 44;
		end
		332:
		begin
			out0 <= 0;
			out1 <= 81;
		end
		333:
		begin
			out0 <= 0;
			out1 <= 93;
		end
		334:
		begin
			out0 <= 1;
			out1 <= 122;
		end
		335:
		begin
			out0 <= 2;
			out1 <= 114;
		end
		336:
		begin
			out0 <= 0;
			out1 <= 82;
		end
		337:
		begin
			out0 <= 0;
			out1 <= 60;
		end
		338:
		begin
			out0 <= 3;
			out1 <= 120;
		end
		339:
		begin
			out0 <= 1;
			out1 <= 118;
		end
		340:
		begin
			out0 <= 0;
			out1 <= 119;
		end
		341:
		begin
			out0 <= 1;
			out1 <= 81;
		end
		342:
		begin
			out0 <= 2;
			out1 <= 121;
		end
		343:
		begin
			out0 <= 1;
			out1 <= 80;
		end
		344:
		begin
			out0 <= 3;
			out1 <= 61;
		end
		345:
		begin
			out0 <= 3;
			out1 <= 18;
		end
		346:
		begin
			out0 <= 3;
			out1 <= 83;
		end
		347:
		begin
			out0 <= 3;
			out1 <= 37;
		end
		348:
		begin
			out0 <= 1;
			out1 <= 115;
		end
		349:
		begin
			out0 <= 1;
			out1 <= 95;
		end
		350:
		begin
			out0 <= 0;
			out1 <= 123;
		end
		351:
		begin
			out0 <= 0;
			out1 <= 23;
		end
		352:
		begin
			out0 <= 3;
			out1 <= 94;
		end
		353:
		begin
			out0 <= 2;
			out1 <= 7;
		end
		354:
		begin
			out0 <= 3;
			out1 <= 82;
		end
		355:
		begin
			out0 <= 0;
			out1 <= 32;
		end
		356:
		begin
			out0 <= 0;
			out1 <= 45;
		end
		357:
		begin
			out0 <= 0;
			out1 <= 105;
		end
		358:
		begin
			out0 <= 1;
			out1 <= 63;
		end
		359:
		begin
			out0 <= 0;
			out1 <= 63;
		end
		360:
		begin
			out0 <= 3;
			out1 <= 111;
		end
		361:
		begin
			out0 <= 2;
			out1 <= 77;
		end
		362:
		begin
			out0 <= 1;
			out1 <= 20;
		end
		363:
		begin
			out0 <= 1;
			out1 <= 60;
		end
		364:
		begin
			out0 <= 2;
			out1 <= 67;
		end
		365:
		begin
			out0 <= 0;
			out1 <= 22;
		end
		366:
		begin
			out0 <= 1;
			out1 <= 85;
		end
		367:
		begin
			out0 <= 1;
			out1 <= 70;
		end
		368:
		begin
			out0 <= 0;
			out1 <= 50;
		end
		369:
		begin
			out0 <= 1;
			out1 <= 34;
		end
		370:
		begin
			out0 <= 1;
			out1 <= 39;
		end
		371:
		begin
			out0 <= 0;
			out1 <= 56;
		end
		372:
		begin
			out0 <= 2;
			out1 <= 3;
		end
		373:
		begin
			out0 <= 1;
			out1 <= 30;
		end
		374:
		begin
			out0 <= 3;
			out1 <= 117;
		end
		375:
		begin
			out0 <= 3;
			out1 <= 25;
		end
		376:
		begin
			out0 <= 0;
			out1 <= 44;
		end
		377:
		begin
			out0 <= 3;
			out1 <= 100;
		end
		378:
		begin
			out0 <= 3;
			out1 <= 97;
		end
		379:
		begin
			out0 <= 2;
			out1 <= 87;
		end
		380:
		begin
			out0 <= 3;
			out1 <= 67;
		end
		381:
		begin
			out0 <= 1;
			out1 <= 7;
		end
		382:
		begin
			out0 <= 2;
			out1 <= 125;
		end
		383:
		begin
			out0 <= 0;
			out1 <= 88;
		end
		384:
		begin
			out0 <= 0;
			out1 <= 16;
		end
		385:
		begin
			out0 <= 3;
			out1 <= 121;
		end
		386:
		begin
			out0 <= 2;
			out1 <= 25;
		end
		387:
		begin
			out0 <= 2;
			out1 <= 76;
		end
		388:
		begin
			out0 <= 2;
			out1 <= 51;
		end
		389:
		begin
			out0 <= 0;
			out1 <= 102;
		end
		390:
		begin
			out0 <= 1;
			out1 <= 96;
		end
		391:
		begin
			out0 <= 0;
			out1 <= 73;
		end
		392:
		begin
			out0 <= 1;
			out1 <= 14;
		end
		393:
		begin
			out0 <= 2;
			out1 <= 106;
		end
		394:
		begin
			out0 <= 0;
			out1 <= 9;
		end
		395:
		begin
			out0 <= 3;
			out1 <= 112;
		end
		396:
		begin
			out0 <= 2;
			out1 <= 109;
		end
		397:
		begin
			out0 <= 1;
			out1 <= 73;
		end
		398:
		begin
			out0 <= 1;
			out1 <= 84;
		end
		399:
		begin
			out0 <= 3;
			out1 <= 53;
		end
		400:
		begin
			out0 <= 0;
			out1 <= 57;
		end
		401:
		begin
			out0 <= 3;
			out1 <= 29;
		end
		402:
		begin
			out0 <= 2;
			out1 <= 34;
		end
		403:
		begin
			out0 <= 0;
			out1 <= 115;
		end
		404:
		begin
			out0 <= 0;
			out1 <= 41;
		end
		405:
		begin
			out0 <= 2;
			out1 <= 126;
		end
		406:
		begin
			out0 <= 2;
			out1 <= 47;
		end
		407:
		begin
			out0 <= 0;
			out1 <= 37;
		end
		408:
		begin
			out0 <= 0;
			out1 <= 39;
		end
		409:
		begin
			out0 <= 0;
			out1 <= 55;
		end
		410:
		begin
			out0 <= 2;
			out1 <= 107;
		end
		411:
		begin
			out0 <= 1;
			out1 <= 12;
		end
		412:
		begin
			out0 <= 2;
			out1 <= 49;
		end
		413:
		begin
			out0 <= 0;
			out1 <= 14;
		end
		414:
		begin
			out0 <= 3;
			out1 <= 65;
		end
		415:
		begin
			out0 <= 0;
			out1 <= 42;
		end
		416:
		begin
			out0 <= 2;
			out1 <= 1;
		end
		417:
		begin
			out0 <= 0;
			out1 <= 48;
		end
		418:
		begin
			out0 <= 2;
			out1 <= 65;
		end
		419:
		begin
			out0 <= 3;
			out1 <= 109;
		end
		420:
		begin
			out0 <= 0;
			out1 <= 43;
		end
		421:
		begin
			out0 <= 3;
			out1 <= 92;
		end
		422:
		begin
			out0 <= 1;
			out1 <= 113;
		end
		423:
		begin
			out0 <= 3;
			out1 <= 59;
		end
		424:
		begin
			out0 <= 0;
			out1 <= 117;
		end
		425:
		begin
			out0 <= 0;
			out1 <= 80;
		end
		426:
		begin
			out0 <= 0;
			out1 <= 79;
		end
		427:
		begin
			out0 <= 2;
			out1 <= 17;
		end
		428:
		begin
			out0 <= 2;
			out1 <= 36;
		end
		429:
		begin
			out0 <= 0;
			out1 <= 94;
		end
		430:
		begin
			out0 <= 3;
			out1 <= 22;
		end
		431:
		begin
			out0 <= 1;
			out1 <= 6;
		end
		432:
		begin
			out0 <= 3;
			out1 <= 31;
		end
		433:
		begin
			out0 <= 3;
			out1 <= 104;
		end
		434:
		begin
			out0 <= 3;
			out1 <= 62;
		end
		435:
		begin
			out0 <= 1;
			out1 <= 76;
		end
		436:
		begin
			out0 <= 0;
			out1 <= 59;
		end
		437:
		begin
			out0 <= 3;
			out1 <= 21;
		end
		438:
		begin
			out0 <= 0;
			out1 <= 69;
		end
		439:
		begin
			out0 <= 0;
			out1 <= 33;
		end
		440:
		begin
			out0 <= 3;
			out1 <= 55;
		end
		441:
		begin
			out0 <= 0;
			out1 <= 29;
		end
		442:
		begin
			out0 <= 2;
			out1 <= 24;
		end
		443:
		begin
			out0 <= 2;
			out1 <= 99;
		end
		444:
		begin
			out0 <= 1;
			out1 <= 86;
		end
		445:
		begin
			out0 <= 0;
			out1 <= 6;
		end
		446:
		begin
			out0 <= 3;
			out1 <= 87;
		end
		447:
		begin
			out0 <= 2;
			out1 <= 120;
		end
		448:
		begin
			out0 <= 1;
			out1 <= 75;
		end
		449:
		begin
			out0 <= 3;
			out1 <= 101;
		end
		450:
		begin
			out0 <= 3;
			out1 <= 72;
		end
		451:
		begin
			out0 <= 1;
			out1 <= 105;
		end
		452:
		begin
			out0 <= 2;
			out1 <= 111;
		end
		453:
		begin
			out0 <= 0;
			out1 <= 72;
		end
		454:
		begin
			out0 <= 2;
			out1 <= 52;
		end
		455:
		begin
			out0 <= 2;
			out1 <= 28;
		end
		456:
		begin
			out0 <= 3;
			out1 <= 114;
		end
		457:
		begin
			out0 <= 1;
			out1 <= 125;
		end
		458:
		begin
			out0 <= 3;
			out1 <= 36;
		end
		459:
		begin
			out0 <= 3;
			out1 <= 54;
		end
		460:
		begin
			out0 <= 0;
			out1 <= 11;
		end
		461:
		begin
			out0 <= 3;
			out1 <= 13;
		end
		462:
		begin
			out0 <= 3;
			out1 <= 41;
		end
		463:
		begin
			out0 <= 3;
			out1 <= 47;
		end
		464:
		begin
			out0 <= 2;
			out1 <= 108;
		end
		465:
		begin
			out0 <= 2;
			out1 <= 91;
		end
		466:
		begin
			out0 <= 2;
			out1 <= 58;
		end
		467:
		begin
			out0 <= 3;
			out1 <= 79;
		end
		468:
		begin
			out0 <= 1;
			out1 <= 16;
		end
		469:
		begin
			out0 <= 3;
			out1 <= 93;
		end
		470:
		begin
			out0 <= 0;
			out1 <= 5;
		end
		471:
		begin
			out0 <= 2;
			out1 <= 103;
		end
		472:
		begin
			out0 <= 0;
			out1 <= 75;
		end
		473:
		begin
			out0 <= 2;
			out1 <= 20;
		end
		474:
		begin
			out0 <= 3;
			out1 <= 32;
		end
		475:
		begin
			out0 <= 3;
			out1 <= 28;
		end
		476:
		begin
			out0 <= 1;
			out1 <= 98;
		end
		477:
		begin
			out0 <= 3;
			out1 <= 5;
		end
		478:
		begin
			out0 <= 1;
			out1 <= 119;
		end
		479:
		begin
			out0 <= 2;
			out1 <= 100;
		end
		480:
		begin
			out0 <= 0;
			out1 <= 104;
		end
		481:
		begin
			out0 <= 3;
			out1 <= 71;
		end
		482:
		begin
			out0 <= 1;
			out1 <= 27;
		end
		483:
		begin
			out0 <= 0;
			out1 <= 124;
		end
		484:
		begin
			out0 <= 2;
			out1 <= 53;
		end
		485:
		begin
			out0 <= 2;
			out1 <= 12;
		end
		486:
		begin
			out0 <= 2;
			out1 <= 46;
		end
		487:
		begin
			out0 <= 1;
			out1 <= 90;
		end
		488:
		begin
			out0 <= 2;
			out1 <= 78;
		end
		489:
		begin
			out0 <= 2;
			out1 <= 92;
		end
		490:
		begin
			out0 <= 1;
			out1 <= 102;
		end
		491:
		begin
			out0 <= 1;
			out1 <= 19;
		end
		492:
		begin
			out0 <= 2;
			out1 <= 27;
		end
		493:
		begin
			out0 <= 2;
			out1 <= 4;
		end
		494:
		begin
			out0 <= 1;
			out1 <= 99;
		end
		495:
		begin
			out0 <= 2;
			out1 <= 70;
		end
		496:
		begin
			out0 <= 3;
			out1 <= 123;
		end
		497:
		begin
			out0 <= 1;
			out1 <= 11;
		end
		498:
		begin
			out0 <= 0;
			out1 <= 89;
		end
		499:
		begin
			out0 <= 1;
			out1 <= 91;
		end
		500:
		begin
			out0 <= 0;
			out1 <= 18;
		end
		501:
		begin
			out0 <= 1;
			out1 <= 3;
		end
		502:
		begin
			out0 <= 1;
			out1 <= 69;
		end
		503:
		begin
			out0 <= 0;
			out1 <= 10;
		end
		504:
		begin
			out0 <= 0;
			out1 <= 90;
		end
		505:
		begin
			out0 <= 0;
			out1 <= 2;
		end
		506:
		begin
			out0 <= 3;
			out1 <= 9;
		end
		507:
		begin
			out0 <= 3;
			out1 <= 1;
		end
		508:
		begin
			out0 <= 2;
			out1 <= 0;
		end
		default:
		begin
			out0 <= 0;
			out1 <= 0;
		end
		endcase
	end
endmodule