module multiplication_mod_61(inp1, inp2, out);
	input [5:0] inp1;
	input [5:0] inp2;
	output reg [5:0] out;
	wire [5:0] out_pre;
	wire [2:0] w_1_0;
	wire [2:0] w_2_0;
	wire [2:0] wout_0;
	wire [1:0] w_1_1;
	wire [1:0] w_2_1;
	wire [1:0] wout_1;
	wire [2:0] w_1_2;
	wire [2:0] w_2_2;
	wire [2:0] wout_2;
	lut_input_61 lut1(inp1, w_1_0, w_1_1, w_1_2);
	lut_input_61 lut2(inp2, w_2_0, w_2_1, w_2_2);
	sum_modulo_4 sm0(w_1_0, w_2_0, wout_0);
	sum_modulo_3 sm1(w_1_1, w_2_1, wout_1);
	sum_modulo_5 sm2(w_1_2, w_2_2, wout_2);
	lut_output_61 lut3(wout_0, wout_1, wout_2, out_pre);
	always @ (*)
	begin
		if (inp1 == 0 || inp2 == 0)
		begin
			out = 0;
		end
		else
		begin
			out = out_pre;
		end
	end
endmodule

module sum_modulo_4(inp1, inp2, out);
	input [2:0] inp1;
	input [2:0] inp2;
	output reg [2:0] out;
	wire [3:0] int;
	assign int = inp1 + inp2;
	always @ (*)
	begin
		if (int < 4)
		begin
			out = int;
		end
		else
		begin
			out = int - 4;
		end
	end
endmodule

module sum_modulo_3(inp1, inp2, out);
	input [1:0] inp1;
	input [1:0] inp2;
	output reg [1:0] out;
	wire [2:0] int;
	assign int = inp1 + inp2;
	always @ (*)
	begin
		if (int < 3)
		begin
			out = int;
		end
		else
		begin
			out = int - 3;
		end
	end
endmodule

module sum_modulo_5(inp1, inp2, out);
	input [2:0] inp1;
	input [2:0] inp2;
	output reg [2:0] out;
	wire [3:0] int;
	assign int = inp1 + inp2;
	always @ (*)
	begin
		if (int < 5)
		begin
			out = int;
		end
		else
		begin
			out = int - 5;
		end
	end
endmodule

module lut_output_61(inp0, inp1, inp2, out);
	output reg [5:0] out;
	input [2:0] inp0;
	input [1:0] inp1;
	input [2:0] inp2;
	always @ (*)
	begin
		if (inp0 == 0 && inp1 == 0 && inp2 == 0)
		begin
			out <= 1;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 1)
		begin
			out <= 2;
		end
		else if (inp0 == 2 && inp1 == 0 && inp2 == 1)
		begin
			out <= 3;
		end
		else if (inp0 == 2 && inp1 == 2 && inp2 == 2)
		begin
			out <= 4;
		end
		else if (inp0 == 2 && inp1 == 1 && inp2 == 2)
		begin
			out <= 5;
		end
		else if (inp0 == 3 && inp1 == 1 && inp2 == 2)
		begin
			out <= 6;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 4)
		begin
			out <= 7;
		end
		else if (inp0 == 3 && inp1 == 0 && inp2 == 3)
		begin
			out <= 8;
		end
		else if (inp0 == 0 && inp1 == 0 && inp2 == 2)
		begin
			out <= 9;
		end
		else if (inp0 == 3 && inp1 == 2 && inp2 == 3)
		begin
			out <= 10;
		end
		else if (inp0 == 3 && inp1 == 0 && inp2 == 0)
		begin
			out <= 11;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 3)
		begin
			out <= 12;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 0)
		begin
			out <= 13;
		end
		else if (inp0 == 2 && inp1 == 2 && inp2 == 0)
		begin
			out <= 14;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 3)
		begin
			out <= 15;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 4)
		begin
			out <= 16;
		end
		else if (inp0 == 3 && inp1 == 2 && inp2 == 2)
		begin
			out <= 17;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 3)
		begin
			out <= 18;
		end
		else if (inp0 == 2 && inp1 == 2 && inp2 == 1)
		begin
			out <= 19;
		end
		else if (inp0 == 0 && inp1 == 0 && inp2 == 4)
		begin
			out <= 20;
		end
		else if (inp0 == 3 && inp1 == 1 && inp2 == 0)
		begin
			out <= 21;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 1)
		begin
			out <= 22;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 2)
		begin
			out <= 23;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 4)
		begin
			out <= 24;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 4)
		begin
			out <= 25;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 1)
		begin
			out <= 26;
		end
		else if (inp0 == 2 && inp1 == 0 && inp2 == 3)
		begin
			out <= 27;
		end
		else if (inp0 == 3 && inp1 == 0 && inp2 == 1)
		begin
			out <= 28;
		end
		else if (inp0 == 3 && inp1 == 2 && inp2 == 0)
		begin
			out <= 29;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 4)
		begin
			out <= 30;
		end
		else if (inp0 == 3 && inp1 == 2 && inp2 == 4)
		begin
			out <= 31;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 0)
		begin
			out <= 32;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 1)
		begin
			out <= 33;
		end
		else if (inp0 == 0 && inp1 == 0 && inp2 == 3)
		begin
			out <= 34;
		end
		else if (inp0 == 3 && inp1 == 2 && inp2 == 1)
		begin
			out <= 35;
		end
		else if (inp0 == 2 && inp1 == 2 && inp2 == 4)
		begin
			out <= 36;
		end
		else if (inp0 == 3 && inp1 == 0 && inp2 == 4)
		begin
			out <= 37;
		end
		else if (inp0 == 3 && inp1 == 0 && inp2 == 2)
		begin
			out <= 38;
		end
		else if (inp0 == 2 && inp1 == 1 && inp2 == 1)
		begin
			out <= 39;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 0)
		begin
			out <= 40;
		end
		else if (inp0 == 2 && inp1 == 0 && inp2 == 4)
		begin
			out <= 41;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 1)
		begin
			out <= 42;
		end
		else if (inp0 == 3 && inp1 == 1 && inp2 == 3)
		begin
			out <= 43;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 2)
		begin
			out <= 44;
		end
		else if (inp0 == 2 && inp1 == 1 && inp2 == 4)
		begin
			out <= 45;
		end
		else if (inp0 == 2 && inp1 == 1 && inp2 == 3)
		begin
			out <= 46;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 0)
		begin
			out <= 47;
		end
		else if (inp0 == 2 && inp1 == 1 && inp2 == 0)
		begin
			out <= 48;
		end
		else if (inp0 == 2 && inp1 == 2 && inp2 == 3)
		begin
			out <= 49;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 0)
		begin
			out <= 50;
		end
		else if (inp0 == 1 && inp1 == 2 && inp2 == 3)
		begin
			out <= 51;
		end
		else if (inp0 == 2 && inp1 == 0 && inp2 == 2)
		begin
			out <= 52;
		end
		else if (inp0 == 1 && inp1 == 0 && inp2 == 3)
		begin
			out <= 53;
		end
		else if (inp0 == 3 && inp1 == 1 && inp2 == 4)
		begin
			out <= 54;
		end
		else if (inp0 == 1 && inp1 == 1 && inp2 == 2)
		begin
			out <= 55;
		end
		else if (inp0 == 0 && inp1 == 1 && inp2 == 2)
		begin
			out <= 56;
		end
		else if (inp0 == 0 && inp1 == 2 && inp2 == 2)
		begin
			out <= 57;
		end
		else if (inp0 == 0 && inp1 == 0 && inp2 == 1)
		begin
			out <= 58;
		end
		else if (inp0 == 3 && inp1 == 1 && inp2 == 1)
		begin
			out <= 59;
		end
		else if (inp0 == 2 && inp1 == 0 && inp2 == 0)
		begin
			out <= 60;
		end
		else 
		begin
			out <= 0;
		end
	end
endmodule

module lut_input_61(inp, out0, out1, out2);
	input [5:0] inp;
	output reg [2:0] out0;
	output reg [1:0] out1;
	output reg [2:0] out2;
	always @ (inp)
	begin
		case(inp)
		1:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 0;
		end
		2:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 1;
		end
		3:
		begin
			out0 <= 2;
			out1 <= 0;
			out2 <= 1;
		end
		4:
		begin
			out0 <= 2;
			out1 <= 2;
			out2 <= 2;
		end
		5:
		begin
			out0 <= 2;
			out1 <= 1;
			out2 <= 2;
		end
		6:
		begin
			out0 <= 3;
			out1 <= 1;
			out2 <= 2;
		end
		7:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 4;
		end
		8:
		begin
			out0 <= 3;
			out1 <= 0;
			out2 <= 3;
		end
		9:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 2;
		end
		10:
		begin
			out0 <= 3;
			out1 <= 2;
			out2 <= 3;
		end
		11:
		begin
			out0 <= 3;
			out1 <= 0;
			out2 <= 0;
		end
		12:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 3;
		end
		13:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 0;
		end
		14:
		begin
			out0 <= 2;
			out1 <= 2;
			out2 <= 0;
		end
		15:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 3;
		end
		16:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 4;
		end
		17:
		begin
			out0 <= 3;
			out1 <= 2;
			out2 <= 2;
		end
		18:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 3;
		end
		19:
		begin
			out0 <= 2;
			out1 <= 2;
			out2 <= 1;
		end
		20:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 4;
		end
		21:
		begin
			out0 <= 3;
			out1 <= 1;
			out2 <= 0;
		end
		22:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 1;
		end
		23:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 2;
		end
		24:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 4;
		end
		25:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 4;
		end
		26:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 1;
		end
		27:
		begin
			out0 <= 2;
			out1 <= 0;
			out2 <= 3;
		end
		28:
		begin
			out0 <= 3;
			out1 <= 0;
			out2 <= 1;
		end
		29:
		begin
			out0 <= 3;
			out1 <= 2;
			out2 <= 0;
		end
		30:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 4;
		end
		31:
		begin
			out0 <= 3;
			out1 <= 2;
			out2 <= 4;
		end
		32:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 0;
		end
		33:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 1;
		end
		34:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 3;
		end
		35:
		begin
			out0 <= 3;
			out1 <= 2;
			out2 <= 1;
		end
		36:
		begin
			out0 <= 2;
			out1 <= 2;
			out2 <= 4;
		end
		37:
		begin
			out0 <= 3;
			out1 <= 0;
			out2 <= 4;
		end
		38:
		begin
			out0 <= 3;
			out1 <= 0;
			out2 <= 2;
		end
		39:
		begin
			out0 <= 2;
			out1 <= 1;
			out2 <= 1;
		end
		40:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 0;
		end
		41:
		begin
			out0 <= 2;
			out1 <= 0;
			out2 <= 4;
		end
		42:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 1;
		end
		43:
		begin
			out0 <= 3;
			out1 <= 1;
			out2 <= 3;
		end
		44:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 2;
		end
		45:
		begin
			out0 <= 2;
			out1 <= 1;
			out2 <= 4;
		end
		46:
		begin
			out0 <= 2;
			out1 <= 1;
			out2 <= 3;
		end
		47:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 0;
		end
		48:
		begin
			out0 <= 2;
			out1 <= 1;
			out2 <= 0;
		end
		49:
		begin
			out0 <= 2;
			out1 <= 2;
			out2 <= 3;
		end
		50:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 0;
		end
		51:
		begin
			out0 <= 1;
			out1 <= 2;
			out2 <= 3;
		end
		52:
		begin
			out0 <= 2;
			out1 <= 0;
			out2 <= 2;
		end
		53:
		begin
			out0 <= 1;
			out1 <= 0;
			out2 <= 3;
		end
		54:
		begin
			out0 <= 3;
			out1 <= 1;
			out2 <= 4;
		end
		55:
		begin
			out0 <= 1;
			out1 <= 1;
			out2 <= 2;
		end
		56:
		begin
			out0 <= 0;
			out1 <= 1;
			out2 <= 2;
		end
		57:
		begin
			out0 <= 0;
			out1 <= 2;
			out2 <= 2;
		end
		58:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 1;
		end
		59:
		begin
			out0 <= 3;
			out1 <= 1;
			out2 <= 1;
		end
		60:
		begin
			out0 <= 2;
			out1 <= 0;
			out2 <= 0;
		end
		default:
		begin
			out0 <= 0;
			out1 <= 0;
			out2 <= 0;
		end
		endcase
	end
endmodule